
/* ----------------------------*/
/* MODEL201.C APPLICATION ---- */
/* NOVEMBER 19, 1997 --------- */
/* LAWSON LABS INC. ---------- */
/* First Release: 11-19-97 --- */
/* Last update:   07-29-98 --- */
/* ----------------------------*/

/****** INCLUDES *****************************/
/*-------------------------------------------*/
#include <formatio.h>
#include <analysis.h>
#include <utility.h>
#include <userint.h>
#include <stdlib.h>
#include <string.h>
#include <ansi_c.h>
#include <rs232.h>
#include <time.h>
#include <stdio.h>
#include "config.h"
#include "warning.h"
#include "main_pnl.h"
#include "filewarn.h"
#include "standby.h"


/* header file for external functions */
#include "201cvi.h"

/* header file for local functions, macros, and variables */
#include "model201.h"

char exitFlag = 0;					
extern openComFlag;
char tempBuff[128];
/*----- END OF INCLUDES ---------------------*/
/*********************************************/

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

/****** MAIN FUNCTION ************************/
/*-------------------------------------------*/

void main(void)
{													  
	char tempBuff[120];
	
	doSignonFlg = 1;

	/* set pointer to function: setMsgRuntime(char *) to point to function */
	/* this pointer is passed to signon function in driver module */
	setMsgRuntimePtr = setMsgRuntime;

	hndMainPnl = LoadPanel (0, "main_pnl.uir", PANEL);
	GetCtrlVal(hndMainPnl, PANEL_OPERATINGMODE, &modeType );
	GetCtrlVal(hndMainPnl, PANEL_FILE_OVERWRITE, &fileOverwriteFlg);

	GetCtrlAttribute(hndMainPnl, PANEL_WAVEFORM, ATTR_PLOT_BGCOLOR,
															&graphBkgrndColor);


	SetCtrlAttribute(hndMainPnl, PANEL_COMPORT, ATTR_VISIBLE, 0);
	SetCtrlAttribute(hndMainPnl, PANEL_BAUDRATE, ATTR_VISIBLE, 0);
	SetCtrlAttribute(hndMainPnl, PANEL_CUT_OFF_FREQ, ATTR_VISIBLE, 0);
	SetCtrlAttribute(hndMainPnl, PANEL_POLARITY_TYPE, ATTR_VISIBLE, 0);
	SetCtrlAttribute(hndMainPnl, PANEL_FILTER, ATTR_VISIBLE, 0);
	SetCtrlAttribute(hndMainPnl, PANEL_AVERAGE, ATTR_VISIBLE, 0);
	SetCtrlAttribute(hndMainPnl, PANEL_WORD_LENGTH, ATTR_VISIBLE, 0);
  	SetCtrlAttribute(hndMainPnl, PANEL_SCAN_INTERVAL, ATTR_VISIBLE, 0);
	SetCtrlAttribute(hndMainPnl, PANEL_SETUP_NOTICE, ATTR_VISIBLE, 0);
	SetCtrlAttribute(hndMainPnl, PANEL_SETUP_NOTICE_2, ATTR_VISIBLE, 0);
	SetCtrlAttribute(hndMainPnl, PANEL_SETUP_NOTICE_3, ATTR_VISIBLE, 0);
	SetCtrlAttribute(hndMainPnl, PANEL_POLL_LINE_INDICATE, ATTR_VISIBLE, 0);
	SetCtrlAttribute(hndMainPnl, PANEL_ATTENTION_LED, ATTR_VISIBLE, 0);
	SetCtrlAttribute(hndMainPnl, PANEL_LOGFILE_PRMPT, ATTR_VISIBLE, 0);
	SetCtrlAttribute(hndMainPnl, PANEL_SELF_CAL_BAK, ATTR_VISIBLE, 0);
	SetCtrlAttribute(hndMainPnl, PANEL_SELFCALIBRATING, ATTR_VISIBLE, 0);
	SetCtrlAttribute(hndMainPnl, PANEL_DIG_PEND_MSG_BAK, ATTR_VISIBLE, 1);
	SetCtrlAttribute(hndMainPnl, PANEL_FILE_OVERWRITE, ATTR_VISIBLE, 0);
	SetCtrlAttribute(hndMainPnl, PANEL_NO_ACTIVE_SUB, ATTR_VISIBLE, 0);

	
	if(modeType == 0)
	{
		opMode = POLLED_MODE;

		SetCtrlAttribute(hndMainPnl, PANEL_SELF_CAL_BAK, ATTR_VISIBLE, 0);
		SetCtrlAttribute(hndMainPnl, PANEL_SELF_CAL_BAK, ATTR_VISIBLE, 0);
		SetCtrlAttribute(hndMainPnl, PANEL_SELF_CAL_BAK, ATTR_VISIBLE, 0);
		SetCtrlAttribute(hndMainPnl, PANEL_SELF_CAL_BAK, ATTR_VISIBLE, 0);
		SetCtrlAttribute(hndMainPnl, PANEL_SELF_CAL_BAK, ATTR_VISIBLE, 0);
		SetCtrlAttribute(hndMainPnl, PANEL_SELF_CAL_BAK, ATTR_VISIBLE, 0);
		SetCtrlAttribute(hndMainPnl, PANEL_SELFCALIBRATING, ATTR_VISIBLE, 0);
		SetCtrlAttribute(hndMainPnl, PANEL_WAVEFORM, ATTR_VISIBLE, 0);
		SetCtrlAttribute(hndMainPnl, PANEL_X_AXIS_RANGE, ATTR_VISIBLE, 0);
		SetCtrlAttribute(hndMainPnl, PANEL_Y_AXIS_RANGE_POS, ATTR_VISIBLE, 0);
		SetCtrlAttribute(hndMainPnl, PANEL_Y_AXIS_RANGE_NEG, ATTR_VISIBLE, 0);
		SetCtrlAttribute(hndMainPnl, PANEL_SCAN_HDR, ATTR_VISIBLE, 0);
		SetCtrlAttribute(hndMainPnl, PANEL_SCAN_DISPLAY, ATTR_VISIBLE, 0);
		SetCtrlAttribute(hndMainPnl, PANEL_BUFF_HDR, ATTR_VISIBLE, 0);
		SetCtrlAttribute(hndMainPnl, PANEL_SCAN_DISPLAY2, ATTR_VISIBLE, 0);
		SetCtrlAttribute(hndMainPnl, PANEL_BUFF_STAT_LED, ATTR_VISIBLE, 0);
		SetCtrlAttribute(hndMainPnl, PANEL_ZOOM, ATTR_VISIBLE, 0);
		SetCtrlAttribute(hndMainPnl, PANEL_AUTOSCALE_X, ATTR_VISIBLE, 0);
		SetCtrlAttribute(hndMainPnl, PANEL_AUTOSCALE_Y, ATTR_VISIBLE, 0);
		SetCtrlAttribute(hndMainPnl, PANEL_AUTO_AXIS_FRAME, ATTR_VISIBLE, 0);
		SetCtrlAttribute(hndMainPnl, PANEL_POLL_DISPLAY, ATTR_VISIBLE, 1);
		SetCtrlAttribute(hndMainPnl, PANEL_POLL_HDR, ATTR_VISIBLE, 1);
		SetCtrlAttribute(hndMainPnl, PANEL_RESET_MAX_MIN, ATTR_VISIBLE, 1);
		SetCtrlAttribute(hndMainPnl, PANEL_POLL_LINE_INDICATE, ATTR_VISIBLE, 1);
	}

	if(modeType == 1)
	{
		opMode = SINGLE_SCAN_MODE;
		M201.tScan = 0;

		SetCtrlAttribute(hndMainPnl, PANEL_SELF_CAL_BAK, ATTR_VISIBLE, 0);
		SetCtrlAttribute(hndMainPnl, PANEL_SELFCALIBRATING, ATTR_VISIBLE, 0);
		SetCtrlAttribute(hndMainPnl, PANEL_WAVEFORM, ATTR_VISIBLE, 1);
		SetCtrlAttribute(hndMainPnl, PANEL_X_AXIS_RANGE, ATTR_VISIBLE, 1);
		SetCtrlAttribute(hndMainPnl, PANEL_Y_AXIS_RANGE_POS, ATTR_VISIBLE, 1);
		SetCtrlAttribute(hndMainPnl, PANEL_Y_AXIS_RANGE_NEG, ATTR_VISIBLE, 1);
		SetCtrlAttribute(hndMainPnl, PANEL_SCAN_HDR, ATTR_VISIBLE, 1);
		SetCtrlAttribute(hndMainPnl, PANEL_SCAN_DISPLAY, ATTR_VISIBLE, 1);
		SetCtrlAttribute(hndMainPnl, PANEL_BUFF_HDR, ATTR_VISIBLE, 1);
		/* SetCtrlAttribute(hndMainPnl, PANEL_SCAN_DISPLAY2, ATTR_VISIBLE, 1); */
		SetCtrlAttribute(hndMainPnl, PANEL_BUFF_STAT_LED, ATTR_VISIBLE, 1);
		SetCtrlAttribute(hndMainPnl, PANEL_ZOOM, ATTR_VISIBLE, 1);
		SetCtrlAttribute(hndMainPnl, PANEL_AUTOSCALE_X, ATTR_VISIBLE, 1);
		SetCtrlAttribute(hndMainPnl, PANEL_AUTOSCALE_Y, ATTR_VISIBLE, 1);
		SetCtrlAttribute(hndMainPnl, PANEL_AUTO_AXIS_FRAME, ATTR_VISIBLE, 1);
		SetCtrlAttribute(hndMainPnl, PANEL_POLL_DISPLAY, ATTR_VISIBLE, 0);
		SetCtrlAttribute(hndMainPnl, PANEL_POLL_HDR, ATTR_VISIBLE, 0);
		SetCtrlAttribute(hndMainPnl, PANEL_RESET_MAX_MIN, ATTR_VISIBLE, 0);
		SetCtrlAttribute(hndMainPnl, PANEL_POLL_LINE_INDICATE, ATTR_VISIBLE, 0);
	}

	if(modeType == 2)
	{
		opMode = MULTI_SCAN_MODE;
		M201.tScan = 1;

		SetCtrlAttribute(hndMainPnl, PANEL_SELF_CAL_BAK, ATTR_VISIBLE, 0);
		SetCtrlAttribute(hndMainPnl, PANEL_SELFCALIBRATING, ATTR_VISIBLE, 0);
		SetCtrlAttribute(hndMainPnl, PANEL_WAVEFORM, ATTR_VISIBLE, 1);
		SetCtrlAttribute(hndMainPnl, PANEL_X_AXIS_RANGE, ATTR_VISIBLE, 1);
		SetCtrlAttribute(hndMainPnl, PANEL_Y_AXIS_RANGE_POS, ATTR_VISIBLE, 1);
		SetCtrlAttribute(hndMainPnl, PANEL_Y_AXIS_RANGE_NEG, ATTR_VISIBLE, 1);
		SetCtrlAttribute(hndMainPnl, PANEL_SCAN_HDR, ATTR_VISIBLE, 1);
		SetCtrlAttribute(hndMainPnl, PANEL_SCAN_DISPLAY, ATTR_VISIBLE, 1);
		SetCtrlAttribute(hndMainPnl, PANEL_BUFF_HDR, ATTR_VISIBLE, 1);
		/* SetCtrlAttribute(hndMainPnl, PANEL_SCAN_DISPLAY2, ATTR_VISIBLE, 0); */
		SetCtrlAttribute(hndMainPnl, PANEL_BUFF_STAT_LED, ATTR_VISIBLE, 1);
		SetCtrlAttribute(hndMainPnl, PANEL_ZOOM, ATTR_VISIBLE, 1);
		SetCtrlAttribute(hndMainPnl, PANEL_AUTOSCALE_X, ATTR_VISIBLE, 1);
		SetCtrlAttribute(hndMainPnl, PANEL_AUTOSCALE_Y, ATTR_VISIBLE, 1);
		SetCtrlAttribute(hndMainPnl, PANEL_AUTO_AXIS_FRAME, ATTR_VISIBLE, 1);
		SetCtrlAttribute(hndMainPnl, PANEL_POLL_DISPLAY, ATTR_VISIBLE, 0);
		SetCtrlAttribute(hndMainPnl, PANEL_POLL_HDR, ATTR_VISIBLE, 0);
		SetCtrlAttribute(hndMainPnl, PANEL_RESET_MAX_MIN, ATTR_VISIBLE, 0);
		SetCtrlAttribute(hndMainPnl, PANEL_POLL_LINE_INDICATE, ATTR_VISIBLE, 0);
	}

	if(modeType == 3)
	{
		opMode = MULTI_SCAN_CAL_MODE;
		M201.tScan = 2;

		SetCtrlAttribute(hndMainPnl, PANEL_SELF_CAL_BAK, ATTR_VISIBLE, 1);
		SetCtrlAttribute(hndMainPnl, PANEL_SELFCALIBRATING, ATTR_VISIBLE, 1);
		SetCtrlAttribute(hndMainPnl, PANEL_WAVEFORM, ATTR_VISIBLE, 1);
		SetCtrlAttribute(hndMainPnl, PANEL_X_AXIS_RANGE, ATTR_VISIBLE, 1);
		SetCtrlAttribute(hndMainPnl, PANEL_Y_AXIS_RANGE_POS, ATTR_VISIBLE, 1);
		SetCtrlAttribute(hndMainPnl, PANEL_Y_AXIS_RANGE_NEG, ATTR_VISIBLE, 1);
 		SetCtrlAttribute(hndMainPnl, PANEL_SCAN_HDR, ATTR_VISIBLE, 1);
		SetCtrlAttribute(hndMainPnl, PANEL_SCAN_DISPLAY, ATTR_VISIBLE, 1);
		SetCtrlAttribute(hndMainPnl, PANEL_BUFF_HDR, ATTR_VISIBLE, 1);
		/* SetCtrlAttribute(hndMainPnl, PANEL_SCAN_DISPLAY2, ATTR_VISIBLE, 0); */
		SetCtrlAttribute(hndMainPnl, PANEL_BUFF_STAT_LED, ATTR_VISIBLE,1);
		SetCtrlAttribute(hndMainPnl, PANEL_ZOOM, ATTR_VISIBLE, 1);
		SetCtrlAttribute(hndMainPnl, PANEL_AUTOSCALE_X, ATTR_VISIBLE, 1);
		SetCtrlAttribute(hndMainPnl, PANEL_AUTOSCALE_Y, ATTR_VISIBLE, 1);
		SetCtrlAttribute(hndMainPnl, PANEL_AUTO_AXIS_FRAME, ATTR_VISIBLE, 1);
		SetCtrlAttribute(hndMainPnl, PANEL_POLL_DISPLAY, ATTR_VISIBLE, 0);
		SetCtrlAttribute(hndMainPnl, PANEL_POLL_HDR, ATTR_VISIBLE, 0);
		SetCtrlAttribute(hndMainPnl, PANEL_RESET_MAX_MIN, ATTR_VISIBLE, 0);
		SetCtrlAttribute(hndMainPnl, PANEL_POLL_LINE_INDICATE, ATTR_VISIBLE, 0);
	}
	
// 10-23-98 ==============================================================	
			GetCtrlVal(hndMainPnl, PANEL_X_AXIS_RANGE, &pointXVal);
			GetCtrlVal(hndMainPnl, PANEL_Y_AXIS_RANGE_POS, &pointYValPos);
			GetCtrlVal(hndMainPnl, PANEL_Y_AXIS_RANGE_NEG, &pointYValNeg);

			if(M201.biPolar)
			SetAxisRange(hndMainPnl, PANEL_WAVEFORM, VAL_MANUAL, 0, pointXVal,
							 VAL_MANUAL, pointYValNeg, pointYValPos);
			else
			SetAxisRange(hndMainPnl, PANEL_WAVEFORM, VAL_MANUAL, 0, pointXVal,
							VAL_MANUAL, fabs(pointYValNeg), fabs(pointYValPos));
// =======================================================================	
	
	

	DisplayPanel (hndMainPnl);
	existMainPnl = TRUE;
	ReadConfig();
	setMainPnlCtrls();
	RunUserInterface();
}

/*----- END OF MAIN FUNCTION ----------------*/
/*********************************************/

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

/****** MAIN PANEL FUNCTIONS *****************/
/*-------------------------------------------*/

int run201 = 0;
int passThru = 0;

int focusMainPnl(int panel, int event, void *callbackData,
					int eventData1, int eventData2)
{
	/* prevent multiple entries */
	static char entryStat = 0;
	if(entryStat > 0) goto dupINSTANCE;
	entryStat++;

	/* lock focus to overlay panels */
	if(hndFileWarnPnl)
	{
		DisplayPanel (hndFileWarnPnl);
		entryStat = 0;
		return 1;
	}
	
	if(hndStandbyPnl)
	{
		DisplayPanel(hndStandbyPnl);
		entryStat = 0;
		return 1;
	}
	
	if(hndWarnPnl)
	{
		DisplayPanel (hndWarnPnl);
		entryStat = 0;
		return 1;
	}


	switch (event)
	{
		case EVENT_LEFT_CLICK:

			/* maintain focus to overlay panel */
			if(hndStatPnl)
			{
				DisplayPanel (hndStatPnl);
			}
			if(hndWarnPnl)
			{
				DisplayPanel (hndWarnPnl);
				entryStat = 0;
				return 1;
			}
	}
dupINSTANCE:
	entryStat = 0;

	return (0);
}

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/


int  CVICALLBACK doChksum(int panel, int control, int event, 
				void *callbackData, int eventData1, int eventData2)
{

	static char entryStat = 0;
	if(entryStat > 0) goto dupINSTANCE;
	entryStat++;
	
	switch (event)
	{
		case EVENT_COMMIT:

		switch(acquireStat)
		{
			case IS_RUNNING:
				if(opMode!= POLLED_MODE)
				{
					setMsgRuntime(" Cannot get checksum while scanning."
										"   ...click 'Stop' and try again.");
					goto dupINSTANCE;
				}
				getChkSumPending = 1;
				break;
				
			case IDLE:
				if(GetCheckSum ())
				{
					setMsgRuntime(" CHECKSUM   ERROR");
					SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 1);
      				setupChanged = SETUP_CHANGED;
 					flashAttention();
				}
				else
				{
					setMsgRuntime(" CHECKSUM  OK");
					SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 0);
      				setupChanged = SETUP_CHANGED;
 					flashAttention();
				}
				break;
				
			default:
				if(doSignonFlg)
				{
					setMsgRuntime(" Cannot get checksum until signed on."
										"   ...click 'start' and try again.");
					SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 1);
				}
				else
				{
					if(GetCheckSum ())
					{
						setMsgRuntime(" CHECKSUM   ERROR");
						SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 1);
      					setupChanged = SETUP_CHANGED;
 						flashAttention();
					}
					else
					{
						setMsgRuntime(" CHECKSUM  OK");
						SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 0);
      					setupChanged = SETUP_CHANGED;
 						flashAttention();
					}
				}
				break;
		}
	}

dupINSTANCE:
	entryStat = 0;
	return 0;
}


/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/


double scanPnt = 0;

int hPR2DLL;
int  AcquireData(int panel, int control, int event,
				void *callbackData, int eventData1, int eventData2)
{
	char tempBuff[1024];
	int i, i2, i3, n;
	char logfileTemp[10];
	char cc[6];

	/* prevent multiple entries */
	static char entryStat = 0;
	if(entryStat > 0) goto dupINSTANCE;
	entryStat++;
			
	if(miscSetup != NO_PENDING) goto dupINSTANCE;

	if(acquireStat == IS_RUNNING) 
		goto dupINSTANCE;
		
		
	switch (event)
	{
		case EVENT_LEFT_CLICK:
		
			if(acquireStat == IDLE)
			{
				if(M201.standBy == 1)
				{
					M201.standBy = 0;
	 				SendADMode(&M201);
	 			}
				SetCtrlAttribute(hndMainPnl, PANEL_STAT, ATTR_ON_COLOR, VAL_GREEN);
				SetCtrlAttribute(hndMainPnl, PANEL_STAT, ATTR_LABEL_TEXT, "- running");
				SetCtrlAttribute(hndMainPnl, PANEL_PAUSE, ATTR_LABEL_TEXT, "__Standby");
				acquireStat = IS_RUNNING;
				DisplayPanel (hndMainPnl);
				goto dupINSTANCE;
			}

			SetCtrlAttribute(hndMainPnl, PANEL_COMPORT, ATTR_VISIBLE, 0);
			SetCtrlAttribute(hndMainPnl, PANEL_BAUDRATE, ATTR_VISIBLE, 0);
			SetCtrlAttribute(hndMainPnl, PANEL_CUT_OFF_FREQ, ATTR_VISIBLE, 0);
			SetCtrlAttribute(hndMainPnl, PANEL_POLARITY_TYPE, ATTR_VISIBLE, 0);
			SetCtrlAttribute(hndMainPnl, PANEL_FILTER, ATTR_VISIBLE, 0);
			SetCtrlAttribute(hndMainPnl, PANEL_AVERAGE, ATTR_VISIBLE, 0);
			SetCtrlAttribute(hndMainPnl, PANEL_WORD_LENGTH, ATTR_VISIBLE, 0);
			SetCtrlAttribute(hndMainPnl, PANEL_SCAN_INTERVAL, ATTR_VISIBLE, 0);
			SetCtrlAttribute(hndMainPnl, PANEL_SETUP_NOTICE, ATTR_VISIBLE, 0);
			SetCtrlAttribute(hndMainPnl, PANEL_SETUP_NOTICE_2, ATTR_VISIBLE, 0);
			SetCtrlAttribute(hndMainPnl, PANEL_SETUP_NOTICE_3, ATTR_VISIBLE, 0);
			SetActiveCtrl(hndMainPnl, PANEL_ACQUIR);

			if(logStat == DO_LOGGING)
			{
				GetCtrlVal(hndMainPnl, PANEL_LOGFILE_NAME, 
				logfileNameTmp);

				/* in case user failed to enter, or erased current logfile name */
				if(strlen(logfileNameTmp) == 0)
					strcpy(logfileNameTmp, "M201LOG");

				/* look for, and remove dot in logfile name */
				dotPtr = strchr(logfileNameTmp, dot);
				if(dotPtr)
					logfileNameTmp[dotPtr - logfileNameTmp] = '\0';

				/* format for 3-digit appearance of logfile name extension */
				if(logfileNum < 10)
				{
					strcat(logfileNameTmp, ".00");
					sprintf(logfileNumArray, "%d", logfileNum);
					strcat(logfileNameTmp, logfileNumArray);
					SetCtrlVal(hndMainPnl, PANEL_LOGFILE_NAME, logfileNameTmp);
				}
				if((logfileNum > 9) && (logfileNum < 100))
				{
					strcat(logfileNameTmp, ".0");
					sprintf(logfileNumArray, "%d", logfileNum);
					strcat(logfileNameTmp, logfileNumArray);
					SetCtrlVal(hndMainPnl, PANEL_LOGFILE_NAME, logfileNameTmp);
				}
				if((logfileNum > 99) && (logfileNum < 1000))
				{
					sprintf(logfileNumArray, ".%d", logfileNum);
					strcat(logfileNameTmp, logfileNumArray);
					SetCtrlVal(hndMainPnl, PANEL_LOGFILE_NAME, logfileNameTmp);
				}
				if(logfileNum > 999)
				{
					SetCtrlVal(hndMainPnl, PANEL_DO_LOG, 0);
					logStat = NO_LOGGING;

					setMsgRuntime(" too many logfiles delete some "
										"and try again  ---NOT LOGGING!");
					SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 1);
					goto NO_LOG;
				}

				logfileNum++;

				strcpy(logfileName, logfileNameTmp);

				if(fileOverwriteFlg == OVERWRITE_PROMPT)
				{
					/* check to see if file exists */
					if(GetFileInfo(logfileName, &fileSize))
					{
						/* preset flag, and wait for it to be changed by user input
							to popup dialog */
						fileOverwritePrmpt = 1;
						hndFileWarnPnl = LoadPanel (0, "filewarn.uir", FILEWARN);
						DisplayPanel (hndFileWarnPnl);
						while(fileOverwritePrmpt == 1)
						{
							ProcessSystemEvents();
						}

						if(fileOverwritePrmpt == DO_OVERWRITE)
						{
							SetCtrlAttribute(hndMainPnl, PANEL_LOGFILE_PRMPT,
												ATTR_VISIBLE, 0);
							fileOverwritePrmpt = 0;
						}
						else
						{
							fileOverwritePrmpt = 0;
							SetCtrlAttribute(hndMainPnl, PANEL_LOGFILE_PRMPT,
												ATTR_VISIBLE, 1);
							SetCtrlVal(hndMainPnl, PANEL_LOGFILE_NAME, "");
							SetActiveCtrl(hndMainPnl, PANEL_LOGFILE_NAME);
							goto dupINSTANCE;
						}
					}
				}
				fileOverwritePrmpt = 0;

				if ((hndLogfile = fopen(logfileName, "wt")) != NULL)
				{
					/* for file-stamp */
					time(&t2);

					switch(opMode)
					{
						case POLLED_MODE:
							sprintf(tempBuff, "%s"
											"\n%s"
											"             channel: %d\n"
											" scan       sub-chan: %d\n",
											logfileName, ctime(&t2), M201.channel, 
											M201.subChan );
							fwrite(tempBuff, strlen(tempBuff), 1, hndLogfile);
							break;
						
						case SINGLE_SCAN_MODE:
							sprintf(tempBuff, "%s"
												"\n%s"
												"             channel: %d\n"
												" scan       sub-chan: %d\n",
												logfileName, ctime(&t2), M201.channel, 
												M201.singleChan & 0x0f);
							fwrite(tempBuff, strlen(tempBuff), 1, hndLogfile);
						 	break;
						 
						case MULTI_SCAN_MODE: 		
						case MULTI_SCAN_CAL_MODE: 	
						  
							sprintf(tempBuff,"%s"
										" %s",logfileName,ctime(&t2));

							if(opMode == MULTI_SCAN_CAL_MODE)
							{
								strcat(tempBuff, "                                  "
												"  chan : sub-chan \n scan#       ");
							}
							else
							{
								strcat(tempBuff, "            chan : sub-chan \n"
												" scan#       ");
							}
							fwrite(tempBuff, strlen(tempBuff), 1, hndLogfile);
							
							if(opMode == MULTI_SCAN_CAL_MODE)
							{
								sprintf(tempBuff, " offset      full-scale ");
								fwrite(tempBuff, strlen(tempBuff), 1, hndLogfile);
							}
						
							for(i = 0; i < 6; i++)
							{
								if(M201.chan[i] != 0xf0)
								{
									for(i2 = (M201.chan[i] >> 4); 
										i2 <= (M201.chan[i] & 0x0f);
										i2++)
									{
										sprintf(tempBuff, "  %d : %-2d    ", i, i2);
										fwrite(tempBuff, strlen(tempBuff), 1, hndLogfile);
									}
								}
							}
							break;
						default:
							break;
					}					

					setMsgRuntime(" logfile successfully opened.           "
										"         ---LOGGING!");
					SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 1);
					goto NO_LOG;
				}
				else
				{
					setMsgRuntime(" Could not re-open logfile.     ---NOT LOGGING!");
					SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 1);
				}
			}

NO_LOG:
			
			SetCtrlAttribute(hndMainPnl, PANEL_STAT, ATTR_ON_COLOR, VAL_BLUE);
			SetCtrlAttribute(hndMainPnl, PANEL_STAT, ATTR_LABEL_TEXT, "- initializing");
			DeleteGraphPlot(hndMainPnl, PANEL_WAVEFORM, -1, VAL_IMMEDIATE_DRAW);
			
			SetCtrlVal(hndMainPnl, PANEL_BUFF_STAT_LED, 0);

			GetCtrlVal(hndMainPnl, PANEL_OPERATINGMODE, &modeType );
			if(modeType == 0)
			{
				opMode = POLLED_MODE;

				pollLineNum = 0;
				ResetTextBox(hndMainPnl, PANEL_POLL_DISPLAY, "");
				memset(pollBuff, '\0', sizeof(pollBuff))	;

				SetCtrlAttribute(hndMainPnl, PANEL_WAVEFORM, ATTR_VISIBLE, 0);
				SetCtrlAttribute(hndMainPnl, PANEL_X_AXIS_RANGE, ATTR_VISIBLE, 0);
				SetCtrlAttribute(hndMainPnl, PANEL_Y_AXIS_RANGE_POS, ATTR_VISIBLE, 0);
				SetCtrlAttribute(hndMainPnl, PANEL_Y_AXIS_RANGE_NEG, ATTR_VISIBLE, 0);
				SetCtrlAttribute(hndMainPnl, PANEL_SCAN_HDR, ATTR_VISIBLE, 0);
				SetCtrlAttribute(hndMainPnl, PANEL_SCAN_DISPLAY, ATTR_VISIBLE, 0);
				SetCtrlAttribute(hndMainPnl, PANEL_BUFF_HDR, ATTR_VISIBLE, 0);
				/* SetCtrlAttribute(hndMainPnl, PANEL_SCAN_DISPLAY2, ATTR_VISIBLE, 0); */
				SetCtrlAttribute(hndMainPnl, PANEL_BUFF_STAT_LED, ATTR_VISIBLE, 0);
				SetCtrlAttribute(hndMainPnl, PANEL_ZOOM, ATTR_VISIBLE, 0);
				SetCtrlAttribute(hndMainPnl, PANEL_AUTOSCALE_X, ATTR_VISIBLE, 0);
				SetCtrlAttribute(hndMainPnl, PANEL_AUTOSCALE_Y, ATTR_VISIBLE, 0);
				SetCtrlAttribute(hndMainPnl, PANEL_AUTO_AXIS_FRAME, ATTR_VISIBLE, 0);
				SetCtrlAttribute(hndMainPnl, PANEL_POLL_DISPLAY, ATTR_VISIBLE, 1);
				SetCtrlAttribute(hndMainPnl, PANEL_POLL_HDR, ATTR_VISIBLE, 1);
				SetCtrlAttribute(hndMainPnl, PANEL_RESET_MAX_MIN, ATTR_VISIBLE, 1);
				SetCtrlAttribute(hndMainPnl, PANEL_POLL_LINE_INDICATE, ATTR_VISIBLE, 1);
			}
			if(modeType == 1)
			{
				GetCtrlVal(hndMainPnl, PANEL_X_AXIS_RANGE, &pointXVal);
				opMode = SINGLE_SCAN_MODE;
				M201.tScan = 0;
				
				SetCtrlAttribute(hndMainPnl, PANEL_WAVEFORM, ATTR_VISIBLE, 1);
				SetCtrlAttribute(hndMainPnl, PANEL_X_AXIS_RANGE, ATTR_VISIBLE, 1);
/// 10-23-98 ===============================================================				
		SetCtrlAttribute(hndMainPnl, PANEL_X_AXIS_RANGE, ATTR_DIMMED, 1);
/// 10-23-98 ===============================================================				
				SetCtrlAttribute(hndMainPnl, PANEL_Y_AXIS_RANGE_POS, ATTR_VISIBLE, 1);
				SetCtrlAttribute(hndMainPnl, PANEL_Y_AXIS_RANGE_NEG, ATTR_VISIBLE, 1);
				SetCtrlAttribute(hndMainPnl, PANEL_SCAN_HDR, ATTR_VISIBLE, 1);
				SetCtrlAttribute(hndMainPnl, PANEL_SCAN_DISPLAY, ATTR_VISIBLE, 1);
				SetCtrlAttribute(hndMainPnl, PANEL_BUFF_HDR, ATTR_VISIBLE, 1);
				/* SetCtrlAttribute(hndMainPnl, PANEL_SCAN_DISPLAY2, ATTR_VISIBLE, 1); */
				SetCtrlAttribute(hndMainPnl, PANEL_BUFF_STAT_LED, ATTR_VISIBLE, 1);
				SetCtrlAttribute(hndMainPnl, PANEL_ZOOM, ATTR_VISIBLE, 1);
				SetCtrlAttribute(hndMainPnl, PANEL_AUTOSCALE_X, ATTR_VISIBLE, 1);
				SetCtrlAttribute(hndMainPnl, PANEL_AUTOSCALE_Y, ATTR_VISIBLE, 1);
				SetCtrlAttribute(hndMainPnl, PANEL_AUTO_AXIS_FRAME, ATTR_VISIBLE, 1);
				SetCtrlAttribute(hndMainPnl, PANEL_POLL_DISPLAY, ATTR_VISIBLE, 0);
				SetCtrlAttribute(hndMainPnl, PANEL_POLL_HDR, ATTR_VISIBLE, 0);
				SetCtrlAttribute(hndMainPnl, PANEL_RESET_MAX_MIN, ATTR_VISIBLE, 0);
				SetCtrlAttribute(hndMainPnl, PANEL_POLL_LINE_INDICATE, ATTR_VISIBLE, 0);	
			}

			if(modeType == 2)
			{
				GetCtrlVal(hndMainPnl, PANEL_X_AXIS_RANGE, &pointXVal);
				opMode = MULTI_SCAN_MODE;
				M201.tScan = 1;
				
				SetCtrlAttribute(hndMainPnl, PANEL_WAVEFORM, ATTR_VISIBLE, 1);
				SetCtrlAttribute(hndMainPnl, PANEL_X_AXIS_RANGE, ATTR_VISIBLE, 1);
/// 10-23-98 ===============================================================				
		SetCtrlAttribute(hndMainPnl, PANEL_X_AXIS_RANGE, ATTR_DIMMED, 1);
/// 10-23-98 ===============================================================				
				SetCtrlAttribute(hndMainPnl, PANEL_Y_AXIS_RANGE_POS, ATTR_VISIBLE, 1);
				SetCtrlAttribute(hndMainPnl, PANEL_Y_AXIS_RANGE_NEG, ATTR_VISIBLE, 1);
				SetCtrlAttribute(hndMainPnl, PANEL_SCAN_HDR, ATTR_VISIBLE, 1);
				SetCtrlAttribute(hndMainPnl, PANEL_SCAN_DISPLAY, ATTR_VISIBLE, 1);
				SetCtrlAttribute(hndMainPnl, PANEL_BUFF_HDR, ATTR_VISIBLE, 1);
				/* SetCtrlAttribute(hndMainPnl, PANEL_SCAN_DISPLAY2, ATTR_VISIBLE, 0); */
				SetCtrlAttribute(hndMainPnl, PANEL_BUFF_STAT_LED, ATTR_VISIBLE, 1);
				SetCtrlAttribute(hndMainPnl, PANEL_ZOOM, ATTR_VISIBLE, 1);
				SetCtrlAttribute(hndMainPnl, PANEL_AUTOSCALE_X, ATTR_VISIBLE, 1);
				SetCtrlAttribute(hndMainPnl, PANEL_AUTOSCALE_Y, ATTR_VISIBLE, 1);
				SetCtrlAttribute(hndMainPnl, PANEL_AUTO_AXIS_FRAME, ATTR_VISIBLE, 1);
				SetCtrlAttribute(hndMainPnl, PANEL_POLL_DISPLAY, ATTR_VISIBLE, 0);
				SetCtrlAttribute(hndMainPnl, PANEL_POLL_HDR, ATTR_VISIBLE, 0);
				SetCtrlAttribute(hndMainPnl, PANEL_RESET_MAX_MIN, ATTR_VISIBLE, 0);
				SetCtrlAttribute(hndMainPnl, PANEL_POLL_LINE_INDICATE, ATTR_VISIBLE, 0);
			}

			if(modeType == 3)
			{
				GetCtrlVal(hndMainPnl, PANEL_X_AXIS_RANGE, &pointXVal);
				opMode = MULTI_SCAN_CAL_MODE;
				M201.tScan = 2;
				
				SetCtrlAttribute(hndMainPnl, PANEL_WAVEFORM, ATTR_VISIBLE, 1);
				SetCtrlAttribute(hndMainPnl, PANEL_X_AXIS_RANGE, ATTR_VISIBLE, 1);
/// 10-23-98 ===============================================================				
		SetCtrlAttribute(hndMainPnl, PANEL_X_AXIS_RANGE, ATTR_DIMMED, 1);
/// 10-23-98 ===============================================================				
				SetCtrlAttribute(hndMainPnl, PANEL_Y_AXIS_RANGE_POS, ATTR_VISIBLE, 1);
				SetCtrlAttribute(hndMainPnl, PANEL_Y_AXIS_RANGE_NEG, ATTR_VISIBLE, 1);
				SetCtrlAttribute(hndMainPnl, PANEL_SCAN_HDR, ATTR_VISIBLE, 1);
				SetCtrlAttribute(hndMainPnl, PANEL_SCAN_DISPLAY, ATTR_VISIBLE, 1);
				SetCtrlAttribute(hndMainPnl, PANEL_BUFF_HDR, ATTR_VISIBLE, 1);
				/* SetCtrlAttribute(hndMainPnl, PANEL_SCAN_DISPLAY2, ATTR_VISIBLE, 0); */
				SetCtrlAttribute(hndMainPnl, PANEL_BUFF_STAT_LED, ATTR_VISIBLE, 1);
				SetCtrlAttribute(hndMainPnl, PANEL_ZOOM, ATTR_VISIBLE, 1);
				SetCtrlAttribute(hndMainPnl, PANEL_AUTOSCALE_X, ATTR_VISIBLE, 1);
				SetCtrlAttribute(hndMainPnl, PANEL_AUTOSCALE_Y, ATTR_VISIBLE, 1);
				SetCtrlAttribute(hndMainPnl, PANEL_AUTO_AXIS_FRAME, ATTR_VISIBLE, 1);
				SetCtrlAttribute(hndMainPnl, PANEL_POLL_DISPLAY, ATTR_VISIBLE, 0);
				SetCtrlAttribute(hndMainPnl, PANEL_POLL_HDR, ATTR_VISIBLE, 0);
				SetCtrlAttribute(hndMainPnl, PANEL_RESET_MAX_MIN, ATTR_VISIBLE, 0);
				SetCtrlAttribute(hndMainPnl, PANEL_POLL_LINE_INDICATE, ATTR_VISIBLE, 0);
			}

			if((acquireStat == IS_RUNNING) || (acquireStat == IDLE))
			{
				acquireStat = NOT_RUNNING;
				SetCtrlAttribute(hndMainPnl, PANEL_STAT, ATTR_ON_COLOR, VAL_BLUE);
				SetCtrlAttribute(hndMainPnl, PANEL_STAT, ATTR_LABEL_TEXT, "- restart");
				DisplayPanel (hndMainPnl);
			}

			if(opMode == POLLED_MODE)
			{
				if(!init_201())
				{
					acquireStat = IS_RUNNING;
					SetCtrlAttribute(hndMainPnl, PANEL_STAT, ATTR_ON_COLOR, VAL_GREEN);
					SetCtrlAttribute(hndMainPnl, PANEL_STAT, ATTR_LABEL_TEXT, "- running");
					SetCtrlAttribute(hndMainPnl, PANEL_PAUSE, ATTR_LABEL_TEXT, "__Standby");
					setMsgRuntime(" Data Acquisition started.");
					SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 0);
				}

				while((opMode == POLLED_MODE)
					&& ((acquireStat == IS_RUNNING) || (acquireStat == IDLE)))
				{
					/* user clicked "pause" */
					while(acquireStat == IDLE)
					{
						ProcessSystemEvents();
					}
					
					/* user may have clicked "stop" while in "pause mode" */
					if(acquireStat == NOT_RUNNING)
								goto dupINSTANCE;
					/* setupOpenedFlg = 0; */
					init_201();
					/* setupOpenedFlg = 0; */
					ProcessSystemEvents();
				}
			}
			else
			{
				/*initialize control code array and calculate total number of points per scan*/
				M201.numChannels = 0;
  				for (n = 0; n <= 5; n++)    
  				{
	 				if(M201.chan[n] != 0xf0)
	 				{
	 					cc[n] = ((M201.chan[n] & 0x0f) - (M201.chan[n] >> 4)) + 1;
	 					/*figure total number of channels/scan */
	 					M201.numChannels += cc[n]; 
	 				}
  				}
				
				if (opMode == POLLED_MODE) M201.tScan = 0;
				i = CheckScanTime(&M201, &maxTime, &minTime);
				switch(i)
				{
					case 0:
						
						M201.scanInterval = requestedScanInterval;
					
						switch(opMode)
						{
							case SINGLE_SCAN_MODE:
						
								setMsgRuntime("Beginning single channel scan");
								SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 0);
								break;

							case MULTI_SCAN_MODE:
								setMsgRuntime("Beginning multi channel scan");
								SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 0);
								break;

							case MULTI_SCAN_CAL_MODE:
								setMsgRuntime("Beginning multi-channel scan with"
											" callibration. ");
								SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 0);
								break;
						}
						setMsgRuntime(" Data Acquisition mode started.");
						SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 0);
						
						/* scanning mode only needs one call to init_201() */
						if(init_201())
						{
							if(scanErrorFlg == SCAN_IN_PROGRESS_ERROR)
							{
								scanErrorFlg == SCAN_NO_ERROR;
								goto dupINSTANCE;
							}
						}
						break;
				
					case 1:
						sprintf(scanIntString, " Scan Interval must be between "
								"%7.4lf-seconds and %7.0lf-seconds", minTime, maxTime);
						setMsgRuntime(scanIntString);
						SetCtrlAttribute(hndMainPnl, PANEL_STAT, ATTR_ON_COLOR, VAL_RED);
						SetCtrlAttribute(hndMainPnl, PANEL_STAT, ATTR_LABEL_TEXT, "- stopped");
						SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 1);
						SetCtrlVal(hndMainPnl, PANEL_SCAN_INTERVAL, M201.scanInterval);
						goto dupINSTANCE;
						break;
				}
			}
	}

dupINSTANCE:
	entryStat = 0;

	return (0);
}

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

void flashAttention()
{
	if(setupChanged)
	{
      	setupChanged = SETUP_NOT_CHANGED;
		SetCtrlAttribute(hndMainPnl, PANEL_ATTENTION_LED, ATTR_VISIBLE, 1);
		DisplayPanel (hndMainPnl);  
		Delay(.125);
		SetCtrlAttribute(hndMainPnl, PANEL_ATTENTION_LED, ATTR_VISIBLE, 0);
		DisplayPanel (hndMainPnl);  
		Delay(.00512);
		SetCtrlAttribute(hndMainPnl, PANEL_ATTENTION_LED, ATTR_VISIBLE, 1);
		DisplayPanel (hndMainPnl);  
		Delay(.75);
		SetCtrlAttribute(hndMainPnl, PANEL_ATTENTION_LED, ATTR_VISIBLE, 0);
		DisplayPanel (hndMainPnl);  
		Delay(.00512);
	}
}

void chgSetupWait()
{
	static char entryStat = 0;
	if(entryStat > 0) goto dupINSTANCE;
	entryStat++;
	
	switch(miscSetup)
	{
		case 1:
			SetCtrlAttribute(hndMainPnl, PANEL_SETUP_NOTICE, ATTR_VISIBLE, 1);
			SetCtrlAttribute(hndMainPnl, PANEL_COMPORT, ATTR_VISIBLE, 1);
			while(miscSetup != NO_PENDING)
				ProcessSystemEvents();
			SetCtrlAttribute(hndMainPnl, PANEL_SETUP_NOTICE, ATTR_VISIBLE, 0);
			SetCtrlAttribute(hndMainPnl, PANEL_COMPORT, ATTR_VISIBLE, 0);
			SetCtrlVal(hndMainPnl, PANEL_SETUP, NO_PENDING);
			break;

		case 2:
			SetCtrlAttribute(hndMainPnl, PANEL_SETUP_NOTICE, ATTR_VISIBLE, 1);
			SetCtrlAttribute(hndMainPnl, PANEL_BAUDRATE, ATTR_VISIBLE, 1);
			while(miscSetup != NO_PENDING)
				ProcessSystemEvents();
			SetCtrlAttribute(hndMainPnl, PANEL_SETUP_NOTICE, ATTR_VISIBLE, 0);
			SetCtrlAttribute(hndMainPnl, PANEL_BAUDRATE, ATTR_VISIBLE, 0);
			SetCtrlVal(hndMainPnl, PANEL_SETUP, NO_PENDING);
			break;

		case 3:
			SetCtrlAttribute(hndMainPnl, PANEL_SETUP_NOTICE_3, ATTR_VISIBLE, 1);
			SetCtrlAttribute(hndMainPnl, PANEL_CUT_OFF_FREQ, ATTR_VISIBLE, 1);
			SetActiveCtrl(hndMainPnl, PANEL_CUT_OFF_FREQ);
			while(miscSetup != NO_PENDING)
				ProcessSystemEvents();
			SetCtrlAttribute(hndMainPnl, PANEL_SETUP_NOTICE_3, ATTR_VISIBLE, 0);
			SetCtrlAttribute(hndMainPnl, PANEL_CUT_OFF_FREQ, ATTR_VISIBLE, 0);
			SetCtrlVal(hndMainPnl, PANEL_SETUP, NO_PENDING);
			break;

		case 4:
			SetCtrlAttribute(hndMainPnl, PANEL_SETUP_NOTICE, ATTR_VISIBLE, 1);
			SetCtrlAttribute(hndMainPnl, PANEL_POLARITY_TYPE, ATTR_VISIBLE, 1);
			while(miscSetup != NO_PENDING)
				ProcessSystemEvents();
			SetCtrlAttribute(hndMainPnl, PANEL_SETUP_NOTICE, ATTR_VISIBLE, 0);
			SetCtrlAttribute(hndMainPnl, PANEL_POLARITY_TYPE, ATTR_VISIBLE, 0);
			SetCtrlVal(hndMainPnl, PANEL_SETUP, NO_PENDING);
			break;

		case 5:
			SetCtrlAttribute(hndMainPnl, PANEL_SETUP_NOTICE, ATTR_VISIBLE, 1);
			SetCtrlAttribute(hndMainPnl, PANEL_FILTER, ATTR_VISIBLE, 1);
			while(miscSetup != NO_PENDING)
				ProcessSystemEvents();
			SetCtrlAttribute(hndMainPnl, PANEL_SETUP_NOTICE, ATTR_VISIBLE, 0);
			SetCtrlAttribute(hndMainPnl, PANEL_FILTER, ATTR_VISIBLE, 0);
			SetCtrlVal(hndMainPnl, PANEL_SETUP, NO_PENDING);
			break;

		case 6: 
			SetCtrlAttribute(hndMainPnl, PANEL_AVERAGE, ATTR_VISIBLE, 1);
			SetCtrlAttribute(hndMainPnl, PANEL_SETUP_NOTICE_2, ATTR_VISIBLE, 1);
			while(miscSetup != NO_PENDING)
				ProcessSystemEvents();
			SetCtrlAttribute(hndMainPnl, PANEL_AVERAGE, ATTR_VISIBLE, 0);
			SetCtrlAttribute(hndMainPnl, PANEL_SETUP_NOTICE_2, ATTR_VISIBLE, 0);
			SetCtrlVal(hndMainPnl, PANEL_SETUP, NO_PENDING);
			break;

		case 7: 
			SetCtrlAttribute(hndMainPnl, PANEL_SETUP_NOTICE, ATTR_VISIBLE, 1);
			SetCtrlAttribute(hndMainPnl, PANEL_WORD_LENGTH, ATTR_VISIBLE, 1);
			while(miscSetup != NO_PENDING)
				ProcessSystemEvents();
			SetCtrlAttribute(hndMainPnl, PANEL_SETUP_NOTICE, ATTR_VISIBLE, 0);
			SetCtrlAttribute(hndMainPnl, PANEL_WORD_LENGTH, ATTR_VISIBLE, 0);
			SetCtrlVal(hndMainPnl, PANEL_SETUP, NO_PENDING);
			break;

		case 8: 
			SetCtrlAttribute(hndMainPnl, PANEL_SETUP_NOTICE_3, ATTR_VISIBLE, 1);
			SetCtrlAttribute(hndMainPnl, PANEL_SCAN_INTERVAL, ATTR_VISIBLE, 1);
			SetActiveCtrl(hndMainPnl, PANEL_SCAN_INTERVAL);
			while(miscSetup != NO_PENDING)
				ProcessSystemEvents();
			SetCtrlAttribute(hndMainPnl, PANEL_SCAN_INTERVAL, ATTR_VISIBLE, 0);
			SetCtrlAttribute(hndMainPnl, PANEL_SETUP_NOTICE_3, ATTR_VISIBLE, 0);
			SetCtrlVal(hndMainPnl, PANEL_SETUP, NO_PENDING);
			break;

	}
	
dupINSTANCE:
	entryStat = 0;

}

int  CVICALLBACK chgSetup(int panel, int control, int event,
				void *callbackData, int eventData1, int eventData2)
{
	static char ctrlVal = 0;

	static char entryStat = 0;
	if(entryStat > 0) goto dupINSTANCE;
	entryStat++;
	
	if((opMode != POLLED_MODE) 
		&& (acquireStat == IS_RUNNING)) 
	{
		setMsgRuntime(" cannot change setup while scanning");
		SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 1);
		entryStat = 0;
		return 1;
	}
	
	switch (event)
	{
		case EVENT_LEFT_CLICK:  
			if(miscSetup != NO_PENDING)
			{
				miscSetup = NO_PENDING;
				SetCtrlAttribute(hndMainPnl, PANEL_COMPORT, ATTR_VISIBLE, 0);
				SetCtrlAttribute(hndMainPnl, PANEL_BAUDRATE, ATTR_VISIBLE, 0);
				SetCtrlAttribute(hndMainPnl, PANEL_CUT_OFF_FREQ, ATTR_VISIBLE, 0);
				SetCtrlAttribute(hndMainPnl, PANEL_POLARITY_TYPE, ATTR_VISIBLE, 0);
				SetCtrlAttribute(hndMainPnl, PANEL_FILTER, ATTR_VISIBLE, 0);
				SetCtrlAttribute(hndMainPnl, PANEL_AVERAGE, ATTR_VISIBLE, 0);
				SetCtrlAttribute(hndMainPnl, PANEL_WORD_LENGTH, ATTR_VISIBLE, 0);
				SetCtrlAttribute(hndMainPnl, PANEL_SCAN_INTERVAL, ATTR_VISIBLE, 0);
				SetCtrlAttribute(hndMainPnl, PANEL_SETUP_NOTICE, ATTR_VISIBLE, 0);
				SetCtrlAttribute(hndMainPnl, PANEL_SETUP_NOTICE_2, ATTR_VISIBLE, 0);
				SetCtrlAttribute(hndMainPnl, PANEL_SETUP_NOTICE_3, ATTR_VISIBLE, 0);
				goto dupINSTANCE;
			}
	  
		case EVENT_COMMIT: 
		case EVENT_VAL_CHANGED:
			
			GetCtrlVal(hndMainPnl, PANEL_SETUP, &ctrlVal);
			/*
			if(M201.filter < 3) setupOpenedFlg = 1;
			*/
			switch(ctrlVal)
			{
				case 1:
					miscSetup = PORT_SET_PENDING;
					PostDeferredCall((void*)chgSetupWait, callbackData);
					break;

				case 2:
					miscSetup = BAUD_SET_PENDING;
					PostDeferredCall((void*)chgSetupWait, callbackData);
					break;

				case 3:
					miscSetup = CUT_OFF_FREQ_SET_PENDING;
					PostDeferredCall((void*)chgSetupWait, callbackData);
					break;

				case 4:
					miscSetup = POLARITY_SET_PENDING;
					PostDeferredCall((void*)chgSetupWait, callbackData);
					break;

				case 5:
					miscSetup = FILTER_SET_PENDING;
					PostDeferredCall((void*)chgSetupWait, callbackData);
					break;

				case 6: 
					miscSetup = AVERAGE_SET_PENDING;
					PostDeferredCall((void*)chgSetupWait, callbackData);
					break;

				case 7: 
					miscSetup = WORD_LENGTH_SET_PENDING;
					PostDeferredCall((void*)chgSetupWait, callbackData);
					break;
					
				case 8: 
					miscSetup = SCAN_INTERVAL_SET_PENDING;
					PostDeferredCall((void*)chgSetupWait, callbackData);
					break;
			}
			doSignonFlg = 1;

		default:
			break;
	}

dupINSTANCE:
	entryStat = 0;

	return (0);

}


/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

int  CVICALLBACK chgFilter(int panel, int control, int event,
									void *callbackData, int eventData1, int eventData2)
{
	static char entryStat = 0;
	
	char tempBuff[20];
	if(entryStat > 0) goto dupINSTANCE;
	entryStat++;
	switch (event)
	{
		case EVENT_LEFT_CLICK:
			miscSetup = NO_PENDING;
			break;
			
		case EVENT_VAL_CHANGED :

			switch(acquireStat)
			{
				case IS_RUNNING:
				case IDLE:

					if(opMode == POLLED_MODE)
					{
						if(ConvPendingFlg)
						{
							if(SendCancel())
							{
								setMsgRuntime(" send-cancel timeout error!");
								SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 1);
							  	goto dupINSTANCE;
							}
						}
					}

					GetCtrlVal(hndMainPnl, PANEL_FILTER, &M201.filter);
					if(M201.filter == 2)
						sprintf(filterString, "Filter: 400 Hz");
					if(M201.filter == 1)
						sprintf(filterString, "Filter: 40 Hz");
					if(M201.filter == 0)
						sprintf(filterString, "Filter: 4 Hz");
			
					SetCtrlVal(hndMainPnl, PANEL_SETUP_FILTER, filterString);
					setMsgRuntime(" Filter setting changed by user.");
					SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 0);
					setupChanged = SETUP_CHANGED;
			
					SetFilter(M201.filter);
					if(SysCal(&M201))
					{
						MessagePopup ("", "syscal failed");
						goto dupINSTANCE;
					}
					
					SetChanCode(&M201);

					stDv=0; rmsBits=0; sdTot = 0; sdAvg=0; sdCount=1;

				default:
				
					GetCtrlVal(hndMainPnl, PANEL_FILTER, &M201.filter);
					if(M201.filter == 2)
						sprintf(filterString, "Filter: 400 Hz");
					if(M201.filter == 1)
						sprintf(filterString, "Filter: 40 Hz");
					if(M201.filter == 0)
						sprintf(filterString, "Filter: 4 Hz");
			
					SetCtrlVal(hndMainPnl, PANEL_SETUP_FILTER, filterString);
					setMsgRuntime(" Filter setting changed by user.");
					SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 0);
					break;
			}
			
		default:
			break;
	}
			
dupINSTANCE:
	entryStat = 0;

	return (0);
}

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

int  CVICALLBACK chgAverage(int panel, int control, int event,
									void *callbackData, int eventData1, int eventData2)
{
	static char entryStat = 0;
	if(entryStat > 0) goto dupINSTANCE;
	entryStat++;

	switch (event)
	{
		switch(acquireStat)
		{
			case IS_RUNNING:
			case IDLE:
					if(opMode == POLLED_MODE)
					{
						if(ConvPendingFlg)
						{
							if(SendCancel())
							{
								setMsgRuntime(" send-cancel timeout error!");
								SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 1);
							  	goto dupINSTANCE;
							}
						}
					}
		}

		case EVENT_LEFT_CLICK:
			miscSetup = NO_PENDING;

		case EVENT_VAL_CHANGED :
			GetCtrlVal(hndMainPnl, PANEL_AVERAGE, &M201.average);
			sprintf(avgString, "Average: %5d", M201.average);
			SetCtrlVal(hndMainPnl, PANEL_SETUP_AVERAGE, avgString);
			setMsgRuntime(" Averaging factor changed by user.");
			SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 0);
			setupChanged = SETUP_CHANGED;
			switch(acquireStat)
			{
				case IS_RUNNING:
				case IDLE:
	 				RemoteAvg(&M201);
			}
		default:
			break;
	}

dupINSTANCE:
	entryStat = 0;

	return (0);
}

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

int  CVICALLBACK chgWordLength(int panel, int control, int event,
									void *callbackData, int eventData1, int eventData2)
{
	static char cancelWaitFlg = 0;
	static char entryStat = 0;
	if(entryStat > 0) goto dupINSTANCE;
	entryStat++;

	switch (event)
	{
		case EVENT_LEFT_CLICK:
			miscSetup = NO_PENDING;

		case EVENT_VAL_CHANGED :
			GetCtrlVal(hndMainPnl, PANEL_WORD_LENGTH, &M201.wordCnt);

			switch(acquireStat)
			{
				case IS_RUNNING:
				case IDLE:
					
					if(opMode == POLLED_MODE)
					{
						if(ConvPendingFlg)
						{
							if(SendCancel())
							{
								setMsgRuntime(" send-cancel timeout error!");
								SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 1);
							  	goto dupINSTANCE;
							}
						}
					}

					SendADMode(&M201); 
					SysCal(&M201); 
					SetChanCode(&M201);
				
					stDv=0; rmsBits=0; sdTot = 0; sdAvg=0; sdCount=1;
					if(M201.wordCnt == 2)
						sprintf(wordLengthString, "Word Length: 16");
					if(M201.wordCnt == 3)
						sprintf(wordLengthString, "Word Length: 24");
					SetCtrlVal(hndMainPnl, PANEL_SETUP_WORD_LENGTH, wordLengthString);
					setMsgRuntime(" Word length changed by user.");
					SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 0);
					setupChanged = SETUP_CHANGED;
				default:
					if(M201.wordCnt == 2)
						sprintf(wordLengthString, "Word Length: 16");
					if(M201.wordCnt == 3)
						sprintf(wordLengthString, "Word Length: 24");
					SetCtrlVal(hndMainPnl, PANEL_SETUP_WORD_LENGTH, wordLengthString);
					setMsgRuntime(" Word length changed by user.");
					SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 0);
					setupChanged = SETUP_CHANGED;
					break;
			}
	}

dupINSTANCE:
	entryStat = 0;

	return (0);
}

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

int chgFileOverwriteStat(int panel, int control, int event,
			void *callbackData, int eventData1, int eventData2)
{
	static char entryStat = 0;
	if(entryStat > 0) goto dupINSTANCE;
	entryStat++;

	switch (event)
	{
		case EVENT_VAL_CHANGED :
			GetCtrlVal(hndMainPnl, PANEL_FILE_OVERWRITE, &fileOverwriteFlg);

		default:
			break;
	}

dupINSTANCE:
	entryStat = 0;

	return (0);
}

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

int  doDebug(int panel, int control, int event,
					void *callbackData, int eventData1, int eventData2)
{
	char tempBuff[80];

	static char entryStat = 0;
	if(entryStat > 0) goto dupINSTANCE;
	entryStat++;

	switch (event)
	{
		case EVENT_LEFT_CLICK:

		sprintf(tempBuff, "%d", M201.singleChan);
		MessagePopup ("", tempBuff);
	}


dupINSTANCE:
	entryStat = 0;

	return (0);

}

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

int  chgZoom(int panel, int control, int event,
					void *callbackData, int eventData1, int eventData2)
{
	return 0;
}

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

/* turns on auto-scale mode for x-axis. Preserves current y-axis mode */
int  autoScaleX(int panel, int control, int event,
					void *callbackData, int eventData1, int eventData2)
{
	int ctrlVal = 0;
	int scaleModeX = 0;
	double xMin = 0;
	double xMax = 0;
	int scaleModeY = 0;
	double yMin = 0;
	double yMax = 0;

	/* prevent multiple entries */
	static char entryStat = 0;
	if(entryStat > 0) goto dupINSTANCE;
	entryStat++;

	switch (event)
	{
	case EVENT_VAL_CHANGED :
			GetCtrlVal(hndMainPnl, PANEL_AUTOSCALE_X, &ctrlVal);
			GetAxisRange(hndMainPnl, PANEL_WAVEFORM, &scaleModeX,
							&xMin, &xMax, &scaleModeY, &yMin, &yMax);

			GetCtrlVal(hndMainPnl, PANEL_X_AXIS_RANGE, &pointXVal);
			GetCtrlVal(hndMainPnl, PANEL_Y_AXIS_RANGE_POS, &pointYValPos);
			GetCtrlVal(hndMainPnl, PANEL_Y_AXIS_RANGE_NEG, &pointYValNeg);

			if(ctrlVal == 1)
			{
				SetAxisRange(hndMainPnl, PANEL_WAVEFORM, VAL_AUTOSCALE,
							0, pointXVal, VAL_NO_CHANGE, pointYValNeg, pointYValPos);
			}
			else
			{
				SetAxisRange(hndMainPnl, PANEL_WAVEFORM, VAL_MANUAL,
							0, pointXVal, VAL_NO_CHANGE, pointYValNeg, pointYValPos);
			}
	}

dupINSTANCE:
	entryStat = 0;

	return 0;
}

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

int  autoScaleY(int panel, int control, int event,
					void *callbackData, int eventData1, int eventData2)
{
	int ctrlVal = 0;
	int scaleModeX = 0;
	double xMin = 0;
	double xMax = 0;
	int scaleModeY = 0;
	double yMin = 0;
	double yMax = 0;

	/* prevent multiple entries */
	static char entryStat = 0;
	if(entryStat > 0) goto dupINSTANCE;
	entryStat++;

	switch (event)
	{
	case EVENT_VAL_CHANGED :
			GetCtrlVal(hndMainPnl, PANEL_AUTOSCALE_Y, &ctrlVal);
			GetAxisRange(hndMainPnl, PANEL_WAVEFORM, &scaleModeX,
							&xMin, &xMax, &scaleModeY, &yMin, &yMax);

			GetCtrlVal(hndMainPnl, PANEL_X_AXIS_RANGE, &pointXVal);
			GetCtrlVal(hndMainPnl, PANEL_Y_AXIS_RANGE_POS, &pointYValPos);
			GetCtrlVal(hndMainPnl, PANEL_Y_AXIS_RANGE_NEG, &pointYValNeg);

			if(ctrlVal)
			{
				SetAxisRange(hndMainPnl, PANEL_WAVEFORM, VAL_NO_CHANGE,
							0, pointXVal, VAL_AUTOSCALE, pointYValNeg, pointYValPos);
			}
			else
			{
				SetAxisRange(hndMainPnl, PANEL_WAVEFORM, VAL_NO_CHANGE,
							0, pointXVal, VAL_MANUAL, pointYValNeg, pointYValPos);
			}
	}

dupINSTANCE:
	entryStat = 0;

	return 0;
}

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

int  chgYAxisRangePos(int panel, int control, int event,
					void *callbackData, int eventData1, int eventData2)
{
	/* prevent multiple entries */
	static char entryStat = 0;
	if(entryStat > 0) goto dupINSTANCE;
	entryStat++;

	switch (event)
	{
		case EVENT_VAL_CHANGED :
			GetCtrlVal(hndMainPnl, PANEL_X_AXIS_RANGE, &pointXVal);
			GetCtrlVal(hndMainPnl, PANEL_Y_AXIS_RANGE_POS, &pointYValPos);
			GetCtrlVal(hndMainPnl, PANEL_Y_AXIS_RANGE_NEG, &pointYValNeg);

			if(M201.biPolar)
			SetAxisRange(hndMainPnl, PANEL_WAVEFORM, VAL_MANUAL, 0, pointXVal,
							 VAL_MANUAL, pointYValNeg, pointYValPos);
			else
			SetAxisRange(hndMainPnl, PANEL_WAVEFORM, VAL_MANUAL, 0, pointXVal,
							VAL_MANUAL, fabs(pointYValNeg), fabs(pointYValPos));
		default:
			break;
	}

dupINSTANCE:
	entryStat = 0;

	return 0;
}

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

int  chgYAxisRangeNeg(int panel, int control, int event,
					void *callbackData, int eventData1, int eventData2)
{
	/* prevent multiple entries */
	static char entryStat = 0;
	if(entryStat > 0) goto dupINSTANCE;
	entryStat++;

	switch (event)
	{
	case EVENT_VAL_CHANGED :
			GetCtrlVal(hndMainPnl, PANEL_X_AXIS_RANGE, &pointXVal);
			GetCtrlVal(hndMainPnl, PANEL_Y_AXIS_RANGE_POS, &pointYValPos);
			GetCtrlVal(hndMainPnl, PANEL_Y_AXIS_RANGE_NEG, &pointYValNeg);
			SetAxisRange(hndMainPnl, PANEL_WAVEFORM, VAL_MANUAL,
							0, pointXVal, VAL_MANUAL, pointYValNeg, pointYValPos);
		default:
			break;
	}

dupINSTANCE:
	entryStat = 0;

	return 0;
}

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

int  chgXAxisRange(int panel, int control, int event,
					void *callbackData, int eventData1, int eventData2)
{
	/* prevent multiple entries */
	static char entryStat = 0;
	if(entryStat > 0) goto dupINSTANCE;
	entryStat++;

	switch (event)
	{
	case EVENT_VAL_CHANGED :
			GetCtrlVal(hndMainPnl, PANEL_X_AXIS_RANGE, &pointXVal);
			GetCtrlVal(hndMainPnl, PANEL_Y_AXIS_RANGE_POS, &pointYValPos);
			GetCtrlVal(hndMainPnl, PANEL_Y_AXIS_RANGE_NEG, &pointYValNeg);

			SetAxisRange(hndMainPnl, PANEL_WAVEFORM, VAL_MANUAL,
							0, pointXVal, VAL_MANUAL, pointYValNeg, pointYValPos);

		default:
			break;
	}

dupINSTANCE:
	entryStat = 0;

	return 0;
}

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

int  setDefMainPnl(int panel, int control, int event,
					void *callbackData, int eventData1, int eventData2)
{
	/* prevent multiple entries */
	static char entryStat = 0;
	if(entryStat > 0) goto dupINSTANCE;
	entryStat++;

	switch (event) {
		case EVENT_LEFT_CLICK :
			switch(acquireStat)
			{
			case IS_RUNNING:
			case IDLE:
				setMsgRuntime(" Function not available while running"
									"   ....press 'stop' and try again");
				SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 1);
				break;
			case NOT_RUNNING:
				setDefaults(FALSE);
				setMsgRuntime(" Configuration set to default values by user.");
				SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 0);
			}
	}
dupINSTANCE:
	entryStat = 0;

	return 0;
}

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

int  logToFile(int panel, int control, int event,
			void *callbackData, int eventData1, int eventData2)
{

	/* prevent multiple entries */
	static char entryStat = 0;
	if(entryStat > 0) goto dupINSTANCE;
	entryStat++;

	GetCtrlVal(hndMainPnl, PANEL_DO_LOG, &logStat);

	switch (event)
	{
	case EVENT_VAL_CHANGED :
	case EVENT_LEFT_CLICK :
		switch(acquireStat)
		{

			case IS_RUNNING:
			case IDLE:
				setMsgRuntime(" Cannot change logfile status while running."
										"   ...click 'Stop' and try again.");

				SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 1);
				if(logStat == DO_LOGGING)
				{
					SetCtrlVal(hndMainPnl, PANEL_DO_LOG, 0);
					SetCtrlAttribute(hndMainPnl, PANEL_FILE_OVERWRITE, ATTR_VISIBLE, 0);
				}
				else
				{
					SetCtrlVal(hndMainPnl, PANEL_DO_LOG, 1);
					SetCtrlAttribute(hndMainPnl, PANEL_FILE_OVERWRITE, ATTR_VISIBLE, 1);
				}
				goto dupINSTANCE;

			default:
				if(logStat == DO_LOGGING)
				{
					if(overwriteOnceFlg)
					{
						SetCtrlAttribute(hndMainPnl, PANEL_FILE_OVERWRITE, ATTR_VISIBLE, 1);
					}

					SetCtrlAttribute(hndMainPnl, PANEL_LOG_LABEL, ATTR_VISIBLE, 1);
					SetCtrlAttribute(hndMainPnl, PANEL_LOGFILE_PRMPT, ATTR_VISIBLE, 1);

					strcpy(logfileName, "M201LOG.001");

					SetCtrlVal(hndMainPnl, PANEL_LOGFILE_NAME, logfileName);
					SetActiveCtrl(hndMainPnl, PANEL_LOGFILE_NAME);
					PostDeferredCall((void*)logfileData, callbackData);
					setMsgRuntime(" user prompted for logfile select status        "
											"                      -- use default?");
					SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 1);

					goto dupINSTANCE;
				}
				else
				{
					SetCtrlAttribute(hndMainPnl, PANEL_LOGFILE_PRMPT, ATTR_VISIBLE, 0);
					SetCtrlAttribute(hndMainPnl, PANEL_FILE_OVERWRITE, ATTR_VISIBLE, 0);
					if(hndLogfile)
					{
						fclose(hndLogfile);
						hndLogfile = 0;
					}
					SetActiveCtrl(hndMainPnl, PANEL_ACQUIR);
					setMsgRuntime(" logfile status changed - no logging");
					SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 0);
					SetCtrlVal(hndMainPnl, PANEL_LOGFILE_NAME, "");
				}
		}
	}

dupINSTANCE:
	entryStat = 0;

	return 0;
}

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

int  logToFileDef(int panel, int control, int event,
							void *callbackData, int eventData1, int eventData2)
{
	/* prevent multiple entries */
	static char entryStat = 0;
	if(entryStat > 0) goto dupINSTANCE;
	entryStat++;

	switch (event)
	{
		case EVENT_VAL_CHANGED :

			SetCtrlAttribute(hndMainPnl, PANEL_LOGFILE_PRMPT, ATTR_VISIBLE, 0);
			SetCtrlAttribute(hndMainPnl, PANEL_LOG_LABEL, ATTR_VISIBLE, 1);
			setMsgRuntime(" logfile status changed    "
								"                           -- using default filename");
			SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 0);

			if(logfileNum > 1)
			{
				SetCtrlVal(hndMainPnl, PANEL_LOGFILE_NAME, logfileName);
				SetActiveCtrl(hndMainPnl, PANEL_LOGFILE_NAME);
			}
			else
			{
				strcpy(logfileName, "M201LOG.001");
				SetCtrlVal(hndMainPnl, PANEL_LOGFILE_NAME, logfileName);
				SetActiveCtrl(hndMainPnl, PANEL_LOGFILE_NAME);
			}
	}

dupINSTANCE:
	entryStat = 0;

	return 0;
}

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

int  logfileData(int panel, int control, int event,
					void *callbackData, int eventData1, int eventData2)
{
	char tempBuff[80];

	/* prevent multiple entries */
	static char entryStat = 0;
	if(entryStat > 0) goto dupINSTANCE;
	entryStat++;

	GetCtrlVal(hndMainPnl, PANEL_DO_LOG, &logStat);

	if(logStat == NO_LOGGING)
	{
		memset(logfileName, '\0', sizeof(logfileName));
		SetCtrlVal(hndMainPnl, PANEL_LOGFILE_NAME, logfileName);
		goto dupINSTANCE;
	}

	switch(acquireStat)
	{
		case IS_RUNNING:
		case IDLE:
			setMsgRuntime(" Cannot change logfile name while running."
										"   ...click 'Stop' and try again.");
			SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 1);
			goto dupINSTANCE;
	}

	switch (event)
	{

	case EVENT_COMMIT :
		switch(acquireStat)
		{
			case IS_RUNNING:
			case IDLE:
				setMsgRuntime(" Cannot change logfile name while running."
										"   ...click 'Stop' and try again.");
				SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 1);
				goto dupINSTANCE;

			default:

				GetCtrlVal(hndMainPnl, PANEL_LOGFILE_NAME, &logfileNameTmp);

				dotPtr = strchr(logfileNameTmp, dot);

				if(dotPtr)
					logfileNameTmp[dotPtr - logfileNameTmp] = '\0';

				if(logfileNum < 10)
				{
					strcat(logfileNameTmp, ".00");
					sprintf(logfileNumArray, "%d", logfileNum);
					strcat(logfileNameTmp, logfileNumArray);
					SetCtrlVal(hndMainPnl, PANEL_LOGFILE_NAME, logfileNameTmp);
				}
				if((logfileNum > 9) && (logfileNum < 100))
				{
					strcat(logfileNameTmp, ".0");
					sprintf(logfileNumArray, "%d", logfileNum);
					strcat(logfileNameTmp, logfileNumArray);
					SetCtrlVal(hndMainPnl, PANEL_LOGFILE_NAME, logfileNameTmp);
				}
				if((logfileNum > 99) && (logfileNum < 1000))
				{
					sprintf(logfileNumArray, ".%d", logfileNum);
					strcat(logfileNameTmp, logfileNumArray);
					SetCtrlVal(hndMainPnl, PANEL_LOGFILE_NAME, logfileNameTmp);
				}

				if(logfileNum > 999)
				{
					SetCtrlVal(hndMainPnl, PANEL_DO_LOG, 0);
					logStat = NO_LOGGING;

					setMsgRuntime(" too many logfiles delete some "
										"and try again  ---NOT LOGGING!");
					SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 1);
					goto dupINSTANCE;
				}

				strcpy(logfileName, logfileNameTmp);

				if(GetFileInfo(logfileName, &fileSize)
							 && (fileOverwriteFlg == OVERWRITE_PROMPT))
				{
					fileOverwritePrmpt = 1;

					hndFileWarnPnl = LoadPanel (0, "filewarn.uir", FILEWARN);
					DisplayPanel (hndFileWarnPnl);

					while(fileOverwritePrmpt == 1)
					{
						ProcessSystemEvents();
					}

					if(fileOverwritePrmpt == DO_OVERWRITE)
					{
						SetCtrlAttribute(hndMainPnl, PANEL_LOGFILE_PRMPT,
												ATTR_VISIBLE, 0);
						fileOverwritePrmpt = 0;
					}
					else
					{
						fileOverwritePrmpt = 0;
						SetCtrlAttribute(hndMainPnl, PANEL_LOGFILE_PRMPT,
												ATTR_VISIBLE, 1);
						SetCtrlVal(hndMainPnl, PANEL_LOGFILE_NAME, "");
						SetActiveCtrl(hndMainPnl, PANEL_LOGFILE_NAME);
						goto dupINSTANCE;
					}
				}

				setMsgRuntime(" logfile name changed ");
				SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 0);
				SetCtrlVal(hndMainPnl, PANEL_LOGFILE_NAME, logfileName);
				SetActiveCtrl(hndMainPnl, PANEL_ACQUIR);
		}
	}


dupINSTANCE:
	entryStat = 0;

	return 0;
}

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

int  chgSzBuffer(int panel, int control, int event,
					void *callbackData, int eventData1, int eventData2)
{
	/* prevent multiple entries */
	static char entryStat = 0;
	if(entryStat > 0) goto dupINSTANCE;
	entryStat++;

	switch (event)
	{
	case EVENT_VAL_CHANGED :
		switch(acquireStat)
		{
			case IS_RUNNING:
			case IDLE:
				setMsgRuntime(" Cannot change input buffer while running."
										"   ...click 'Stop' and try again.");
				SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 1);
				break;
			default:
				setMsgRuntime(" input buffer changed by user.");
				SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 0);
				SetActiveCtrl(hndMainPnl, PANEL_ACQUIR);
		}
	}
dupINSTANCE:
	entryStat = 0;

	return 0;
}

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

int  resetMAX_MIN(int panel, int control, int event,
				void *callbackData, int eventData1, int eventData2)
{
	/* prevent multiple entries */
	static char entryStat = 0;
	if(entryStat > 0) goto dupINSTANCE;
	entryStat++;

	switch (event)
	{
		case EVENT_LEFT_CLICK :
			MaxMinReset = 1;
	}

dupINSTANCE:
	entryStat = 0;

	return 0;
}

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

int  savCurrentConfig(int panel, int control, int event,
					void *callbackData, int eventData1, int eventData2)
{
	/* prevent multiple entries */
	static char entryStat = 0;
	if(entryStat > 0) goto dupINSTANCE;
	entryStat++;

	switch (event)
	{
	case EVENT_LEFT_CLICK :
		switch(acquireStat)
		{
			case IS_RUNNING:
				setMsgRuntime(" Cannot save file while running."
										"  ....click 'Stop' and try again.");
				SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 1);
				break;
			default:
				WriteConfig();
				setMsgRuntime(" Current configuration saved to:  M201_CVI.CFG");
				SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 0);
		}
	}

dupINSTANCE:
	entryStat = 0;

	return 0;
}

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

int  loadConfiguration(int panel, int control, int event,
					void *callbackData, int eventData1, int eventData2)
{
	/* prevent multiple entries */
	static char entryStat = 0;
	if(entryStat > 0) goto dupINSTANCE;
	entryStat++;

	switch (event)
	{
	case EVENT_LEFT_CLICK :
		switch(acquireStat)
		{
			case IS_RUNNING:
			case IDLE:
				setMsgRuntime(" Cannot load file while running."
										"  ....click 'Stop' and try again.");
				SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 1);
				break;
			case NOT_RUNNING:
				ReadConfig();
				setMainPnlCtrls();
				setMsgRuntime(" Current configuration loaded from:   M201_CVI.CFG");
				SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 0);
		}
	}

dupINSTANCE:
	entryStat = 0;

	return 0;
}

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

int  chgBaud(int panel, int control, int event,
					void *callbackData, int eventData1, int eventData2)
{
	int valBaud;

	long 						bauds[]={  /*  table for baud rate codes  */
								/* 0  */  9600,
								/* 1  */  4800,
								/* 2  */  2400,
								/* 3  */  1200,
								/* 4  */   600,
								/* 5  */   300};

	/* prevent multiple entries */
	static char entryStat = 0;
	if(entryStat > 0) goto dupINSTANCE;
	entryStat++;

	switch (event)
	{
	case EVENT_LEFT_CLICK:
		miscSetup = NO_PENDING;

	case EVENT_VAL_CHANGED :
		switch(acquireStat)
		{
			case IS_RUNNING:
			case IDLE:
				setMsgRuntime(" Cannot change baud while running."
										"   ...click 'Stop' and try again.");
				SetCtrlVal(hndMainPnl, PANEL_BAUDRATE, M201.baud);
				SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 1);
				break;
			default:
				GetCtrlVal(hndMainPnl, PANEL_BAUDRATE, &valBaud);
				M201.baud = (short)valBaud;
				sprintf(baudString, "BAUD:  %4d", bauds[M201.baud]);
				SetCtrlVal(hndMainPnl, PANEL_SETUP_BAUD, baudString);
				setMsgRuntime(" BaudRate changed by user.");
				SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 0);
				setupChanged = SETUP_CHANGED;
		}
	}

dupINSTANCE:
	entryStat = 0;

	return 0;
}

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

int  getDigIn2(int panel, int control, int event,
					void *callbackData, int eventData1, int eventData2)
{
	static int digCtrlVal = 0;
	char iPtr = 0;
	int iCnt = 128;

	/* prevent multiple entries */
	static char entryStat = 0;
	if(entryStat > 0) goto dupINSTANCE;
	entryStat++;

	switch (event)
	{
	case EVENT_LEFT_CLICK:

		if((acquireStat == NOT_RUNNING) && (doSignonFlg == 1))
		{
			setMsgRuntime(" Cannot get digital input while not running.");
			SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 1);
			goto dupINSTANCE;
		}
 		
		if(acquireStat == IS_RUNNING)
		{
			if(opMode != POLLED_MODE)
			{
				setMsgRuntime(" Cannot get digital input while running in scan-mode");
				SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 1);
				goto dupINSTANCE;
			}
		}
	
		if(ConvPendingFlg)
		{
			if(SendCancel())
			{
				setMsgRuntime(" send-cancel timeout error!");
				SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 1);
				goto dupINSTANCE;
			}
		}

		GetDigIn(&M201);

		for(iPtr = 8; iPtr > 0; iPtr--)
		{
				SetCtrlVal(hndMainPnl, PANEL_DI_7 - (iPtr - 1), 0);
		}

		for(iPtr = 0; iPtr < 8; iPtr++)
		{
			if((M201.lastDigInp & iCnt) == iCnt)
			{
				SetCtrlVal(hndMainPnl, PANEL_DI_7 - (iPtr), 1);
			}

			iCnt = iCnt / 2;
		}
	}
		


dupINSTANCE:
	entryStat = 0;

	return 0;
}

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/


int  sendDigOut(int panel, int control, int event,
				void *callbackData, int eventData1, int eventData2)
{

	static char entryStat = 0;
	if(entryStat > 0) goto dupINSTANCE;
	entryStat++;

	switch (event)
	{
		case EVENT_LEFT_CLICK:
			
			if((acquireStat == NOT_RUNNING) && (doSignonFlg == 1))
			{
				setMsgRuntime(" Cannot send digital output while not running.");
				SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 1);
				goto dupINSTANCE;
			}
			
			M201.digOutWord = newDigOut;
			SetDigOut(M201.digOutWord);
			SetCtrlVal(hndMainPnl, PANEL_DIGOUT_PENDING, 0);
			SetCtrlAttribute(hndMainPnl, PANEL_DIG_PEND_MSG_BAK, ATTR_VISIBLE, 1);
			SetCtrlVal(hndMainPnl, PANEL_DIGOUT_PEND_MSG, "");
			setMsgRuntime(" DIGITAL OUTPUT  changed by user.");
			SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 0);
	}

dupINSTANCE:
	entryStat = 0;

	return 0;
}

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/



int  chgDigOut(int panel, int control, int event,
						void *callbackData, int eventData1, int eventData2)
{
	static int digCtrlVal = 0;
	char iPtr = 0;
	int iCnt = 128;

	/* prevent multiple entries */
	static char entryStat = 0;
	if(entryStat > 0) goto dupINSTANCE;
	entryStat++;

	switch (event)
	{
	case EVENT_VAL_CHANGED :

		newDigOut = 0;

		GetCtrlVal(hndMainPnl, control, &digCtrlVal);

		digOutArray[abs(control - PANEL_DO_7)] = digCtrlVal;
		for(iPtr = 8; iPtr > 0; iPtr--)
		{
			if(digOutArray[(iPtr - 1)] == 1)
				newDigOut = newDigOut + iCnt;
				iCnt /= 2;
		}
		SetCtrlVal(hndMainPnl, PANEL_DIGOUT_PENDING, 1);
		SetCtrlAttribute(hndMainPnl, PANEL_DIG_PEND_MSG_BAK, ATTR_VISIBLE, 1);
		SetCtrlVal(hndMainPnl, PANEL_DIGOUT_PEND_MSG, "dig-out pending");
	}

dupINSTANCE:
	entryStat = 0;

	return 0;
}

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

int  chgChannel(int panel, int control, int event,
					void *callbackData, int eventData1, int eventData2)
{
	int valChannel;
	int cnt = 0, n = 0, s = 0, iCnt = 0;
	int ctrlNum = 0;
	int ctrlVal = 0;

	/* prevent multiple entries */
	static char entryStat = 0;
	if(entryStat > 0) goto dupINSTANCE;
	entryStat++;

	GetCtrlVal(hndMainPnl, PANEL_OPERATINGMODE, &modeType );

	switch (event)
	{
	/* case EVENT_VAL_CHANGED: */
	case EVENT_COMMIT:
		GetCtrlVal(hndMainPnl, PANEL_CHANNELSELECT, &valChannel);
		switch(modeType)
		{
			case SINGLE_SCAN_MODE:
				GetCtrlVal(hndMainPnl, PANEL_CHANNELSELECT, &valChannel);
				M201.singleChan = M201.singleChan & 0x0f;
				M201.singleChan = M201.singleChan | ((short)valChannel << 4);
				M201.channel = (short)valChannel;
      			if(acquireStat != IS_RUNNING)
      			{
      				setupChanged = SETUP_CHANGED;
 					flashAttention();
 				}
 				else
 				{
					ChanReset = 1;
 				}
				
				break;
				
			case POLLED_MODE:
				M201.channel = (short)valChannel;
				setMsgRuntime(" Channel Select changed by user.");
				SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 0);
      			setupChanged = SETUP_CHANGED;
 				flashAttention();
				ChanReset = 1;
				goto dupINSTANCE;
				break;
			
			case MULTI_SCAN_MODE:
			case MULTI_SCAN_CAL_MODE:
				 
				GetCtrlVal(hndMainPnl, PANEL_CHANNELSELECT, &valChannel);
				M201.channel = valChannel;
				for(iCnt = 0; iCnt < 16; iCnt++)
				{	
					SetCtrlVal(hndMainPnl, PANEL_C0 + iCnt, 0);
					if(subChanSelect[M201.channel][SCAptr] == 's')
						SetCtrlVal(hndMainPnl, PANEL_C0 + iCnt, 1);
				}
			
				for(cnt=0; cnt <16 ; cnt++)
 				{
 					SetCtrlAttribute(hndMainPnl, PANEL_C0 + cnt, 
 										ATTR_ON_COLOR, VAL_WHITE);
 				}				
			
				if(M201.channel > 5)
				{
					setMsgRuntime(" No active sub-channels for this channel.");
					activeChannelIndex = 0;
					SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 1);
					goto dupINSTANCE;
				
				}
				
				if(M201.chan[M201.channel] == 0xf0)
				{
					setMsgRuntime(" No active sub-channels for this channel.");
					activeChannelIndex = 0;
					SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 1);
					goto dupINSTANCE;
				}
				
				SetCtrlAttribute(hndMainPnl, PANEL_C0 + 
							(M201.chan[M201.channel] >> 4), 
							ATTR_ON_COLOR, VAL_GREEN);         			
			
				activeSubChannel = (M201.chan[M201.channel] & 0xf0) >> 4;
	
				/* Calculate the ActiveChannelIndex   */
				activeChannelIndex = 0;
				activeChannel = M201.channel;
			
				for (n = 0; n <6; n++)
				{
					for (s = 0; s <16; s++)
					{
		 				if (subChanSelect[n][s] == 's')
		 				{
		 					activeChannelIndex++;
		 					if ((n==activeChannel)&&(s==activeSubChannel)) goto DONETHIS;
		 				}
					}
				}
DONETHIS:		if(activeChannelIndex) activeChannelIndex--;
				
				break;
		}
		setMsgRuntime(" Channel Select changed by user.");
		SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 0);
		setMainPnlCtrls();
	}

dupINSTANCE:
	entryStat = 0;

	return 0;
}

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

int  subSelect(int panel, int control, int event,
					void *callbackData, int eventData1, int eventData2)
{
	/* prevent multiple entries */
	static char entryStat = 0;
	if(entryStat > 0) goto dupINSTANCE;
	entryStat++;

	if(subSetPassFlg) 
	{
		subSetPassFlg = 0;
		goto dupINSTANCE;
	}

	switch (event)
	{
	case EVENT_RIGHT_CLICK:
		chgSubChan(control, event);
		break;
	
	case EVENT_VAL_CHANGED:
		chgSubChan(control, event);
	}

dupINSTANCE:
	entryStat = 0;

	return 0;
}


/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

int chgSubChan(int ctrlNum, int event)
{
	char tempBuff [40];
	int ctrlVal = 0;
	int cnt = 0, cnt2 = 0;
	char lowSub = 0, highSub = 0, n, s;

	GetCtrlVal(hndMainPnl, PANEL_OPERATINGMODE, &modeType );
	
	if((modeType == POLLED_MODE) && (event != EVENT_RIGHT_CLICK))
	{
		if((M201.channel == 6) || (M201.channel == 7))
		{
			setMsgRuntime(" cannot select sub-channel "
									"when channel 6 or 7 selected");
			SetCtrlVal(hndMainPnl, ctrlNum, 0);
			SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 1);
			return 0;
		}

		GetCtrlVal(hndMainPnl, ctrlNum, &ctrlVal );

		if(ctrlVal == 1)
		{
			for(cnt = 0; cnt < 16; cnt++)
				SetCtrlVal(hndMainPnl, PANEL_C0 + cnt, 0);

			M201.subChan = CTRL_OFFSET;
			SetCtrlVal(hndMainPnl, ctrlNum, 1);
			setMsgRuntime(" new sub-channel selected");
			SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 0);
			subSetPassFlg = 0;
		}
		else
		{
			M201.subChan = 0;
			SetCtrlVal(hndMainPnl, PANEL_C0, 1);
			setMsgRuntime(" sub-channel de-selected");
			SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 0);
			subSetPassFlg = 0;
		}

      	setupChanged = SETUP_CHANGED;
 		flashAttention();
		ChanReset = 1;
		return 0;
	}

	if((modeType == SINGLE_SCAN_MODE) && (event != EVENT_RIGHT_CLICK))
	{
		if((M201.channel == 6) || (M201.channel == 7))
		{
			setMsgRuntime(" cannot select sub-channel "
									"when channel 6 or 7 selected");
			SetCtrlVal(hndMainPnl, ctrlNum, 0);
			SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 1);
			return 0;
		}

		GetCtrlVal(hndMainPnl, ctrlNum, &ctrlVal );
		if(ctrlVal == 1)
		{                                                   
			for(cnt = 0; cnt < 16; cnt++)
					SetCtrlVal(hndMainPnl, PANEL_C0 + cnt, 0);

			/* single channel scan alters, and uses M201.subChan while running */
			if(acquireStat == IS_RUNNING)
				M201.subChan = CTRL_OFFSET;
			M201.singleChan = M201.singleChan & 0x0f0;
			M201.singleChan = M201.singleChan | CTRL_OFFSET;
			subSetPassFlg = 1;
			SetCtrlVal(hndMainPnl, ctrlNum, 1);
			SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 0);
			setMsgRuntime(" new sub-channel selected");
			subSetPassFlg = 0;
      		
      		if(acquireStat != IS_RUNNING)
      		{
      			setupChanged = SETUP_CHANGED;
 				flashAttention();
 			}
			ChanReset = 1;
 		}
		else
		{
			M201.singleChan = M201.singleChan & 0x0f0;
			SetCtrlVal(hndMainPnl, ctrlNum, 0);
			SetCtrlVal(hndMainPnl, PANEL_C0, 1);
			SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 0);
			setMsgRuntime(" sub-channel de-selected");
 		}
 		doSignonFlg = 1;
 		return 0;
	}

	if((modeType == MULTI_SCAN_MODE) || (modeType == MULTI_SCAN_CAL_MODE))
	{
		
		if((M201.channel == 6) || (M201.channel == 7))
		{
			setMsgRuntime(" cannot select sub-channel "
									"when channel full scale or zero volts selected");
			SetCtrlVal(hndMainPnl, ctrlNum, 0);
			SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 1);
			return 0;
		}
		
		if((acquireStat == IS_RUNNING) 
			|| (acquireStat == IDLE))
		{
			if(event != EVENT_RIGHT_CLICK)
			{
				GetCtrlVal(hndMainPnl, ctrlNum, &ctrlVal );
				if(ctrlVal == 1)
					SetCtrlVal(hndMainPnl, ctrlNum, 0);
				if(ctrlVal == 0)
					SetCtrlVal(hndMainPnl, ctrlNum, 1);
				
				setMsgRuntime(" Cannot change sub channels while running "
									"in multi-chan scan mode" );
				SetCtrlVal(hndMainPnl, PANEL_CHANNELSELECT, M201.channel);
				SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 1);
				return 0;
			}
		}
		
		if(event == EVENT_RIGHT_CLICK)
		{
			
			cnt = 0;
			if( CTRL_OFFSET > (M201.chan[M201.channel] & 0x0f)
				|| CTRL_OFFSET < (M201.chan[M201.channel] >> 4))
			{
				return 0;
			}
			
			for( cnt=0; cnt <16 ; cnt++)
 			{
 				SetCtrlAttribute(hndMainPnl, PANEL_C0 + cnt, 
 										ATTR_ON_COLOR, VAL_WHITE);
 			}				
			
			SetCtrlAttribute(hndMainPnl, ctrlNum, ATTR_ON_COLOR, VAL_GREEN);         			
			activeSubChannel = (char)CTRL_OFFSET;
	
			/* Calculate the ActiveChannelIndex   */
			activeChannelIndex = 0;
			activeChannel = M201.channel;
			
			for (n = 0; n <6; n++)
			{
				for (s = 0; s <16; s++)
				{
		 			if (subChanSelect[n][s] == 's')
		 			{
		 				activeChannelIndex++;
		 				if ((n==activeChannel)&&(s==activeSubChannel)) goto DONETHIS;
		 			}
				}
			}
DONETHIS:	if(activeChannelIndex) activeChannelIndex--;
			return 0;
		}
		
		cnt = 0;
		GetCtrlVal(hndMainPnl, ctrlNum, &ctrlVal );
		if(ctrlVal == 1)
		{
			if(M201.chan[M201.channel] == 0xf0)
			{
				SetCtrlVal(hndMainPnl, ctrlNum, 1);  
				subChanSelect[M201.channel][CTRL_OFFSET] = 's';
				M201.chan[M201.channel] = 0;
				M201.chan[M201.channel] = M201.chan[M201.channel] | CTRL_OFFSET;
				M201.chan[M201.channel] = M201.chan[M201.channel] | (CTRL_OFFSET << 4); 
				setMsgRuntime(" new sub-channel(s) selected");
				SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 0);
				subSetPassFlg = 1;  
				setActiveSubChan();
				return 0;
			}
			
			if((CTRL_OFFSET < (M201.chan[M201.channel] >> 4)))
			{
				cnt = (M201.chan[M201.channel]) >> 4;
				cnt2 = 0;
				for(cnt = CTRL_OFFSET; cnt < (M201.chan[M201.channel]  >> 4); cnt++)
				{
					SetCtrlVal(hndMainPnl, ctrlNum + cnt2, 1);
					cnt2++;
				}
				
				M201.chan[M201.channel] = 
					(M201.chan[M201.channel] & 0x0f) | (CTRL_OFFSET << 4);
				for(cnt = (M201.chan[M201.channel] & 0xf0)>> 4; 
						cnt < (M201.chan[M201.channel] & 0x0f);
						cnt ++)
				{
					subChanSelect[M201.channel][cnt] = 's';
				}
				setMsgRuntime(" new sub-channel selected");
				SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 0);
				
				setActiveSubChan();
				return 0;
			}
			if(CTRL_OFFSET > (M201.chan[M201.channel] & 0x0f))
			{
				cnt2 = 0;
				for(cnt = CTRL_OFFSET; cnt > (M201.chan[M201.channel] & 0x0f); cnt--)
				{
					SetCtrlVal(hndMainPnl, ctrlNum - cnt2, 1);
					cnt2++;
				}
				M201.chan[M201.channel] =
					(M201.chan[M201.channel] & 0xf0) | CTRL_OFFSET;
				for(cnt = (M201.chan[M201.channel] & 0x0f);
						cnt > ((M201.chan[M201.channel] & 0xf0) >> 4);
						cnt--)
				{
					subChanSelect[M201.channel][cnt] = 's';
				}
				setMsgRuntime(" new sub-channel(s) selected");
				SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 0);
				return 0;
			}
 		}
		else
		{
			cnt2 = 0;
			
			n = (M201.chan[M201.channel] & 0x0f) - 
				(M201.chan[M201.channel] >> 4);
					
			if(!n)
			{
				M201.chan[M201.channel] = 0xf0;
				subChanSelect[M201.channel][CTRL_OFFSET] = 'c';
				setMsgRuntime(" sub-channel de-selected");
				SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 0);
				setActiveSubChan();
				return 0;
			}
			
			if(CTRL_OFFSET < ((M201.chan[M201.channel] & 0x0f) - (n / 2)))
			{
				for(cnt = CTRL_OFFSET; 
					cnt > ((M201.chan[M201.channel] & 0xf0) >> 4 ); 
					cnt--)
				{
					cnt2++;
					SetCtrlVal(hndMainPnl, ctrlNum - cnt2, 0);
				}
				
				M201.chan[M201.channel] = 
					(M201.chan[M201.channel] & 0x0f) | ((CTRL_OFFSET + 1) << 4);
				
				for(cnt = ((M201.chan[M201.channel] & 0xf0) >> 4) - 1; 
						cnt > 0; cnt--)
				{
					subChanSelect[M201.channel][cnt] = 'c';
				}
				setMsgRuntime(" sub-channel(s) de-selected");
				SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 0);

				setActiveSubChan();
				return 0;
			}
			else
			{
				for(cnt = CTRL_OFFSET; 
					cnt < (M201.chan[M201.channel] & 0x0f) ; 
					cnt++)
				{
					cnt2++;
					SetCtrlVal(hndMainPnl, ctrlNum + cnt2, 0);
				}
				
				M201.chan[M201.channel] = 
					(M201.chan[M201.channel] & 0xf0)  
					| (CTRL_OFFSET - 1);
				
				for(cnt = (M201.chan[M201.channel] & 0x0f) + 1; 
						cnt < 16; cnt++)
				{
					subChanSelect[M201.channel][cnt] = 'c';
				}
				
				setMsgRuntime(" sub-channel(s) de-selected");
				SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 0);
			}
		}
		/*
		setActiveSubChan();
		*/
	}

	return 0;
}

int setActiveSubChan(void)
{
	int cnt = 0, n = 0, s = 0;
	
	for(cnt=0; cnt <16 ; cnt++)
 	{
 		SetCtrlAttribute(hndMainPnl, PANEL_C0 + cnt, 
 										ATTR_ON_COLOR, VAL_WHITE);
 	}				
			
	if(M201.chan[M201.channel] == 0xf0)
	{
		setMsgRuntime(" No active sub-channels for this channel.");
		activeChannelIndex = 0xf0;
		SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 1);
		return 0;
	}
			
	SetCtrlAttribute(hndMainPnl, PANEL_C0 + 
				(M201.chan[M201.channel] >> 4), 
				ATTR_ON_COLOR, VAL_GREEN);         			
			
	activeSubChannel = (M201.chan[M201.channel] & 0xf0) >> 4;
	
	/* Calculate the ActiveChannelIndex   */
	activeChannelIndex = 0;
	activeChannel = M201.channel;
			
	for (n = 0; n <6; n++)
	{
		for (s = 0; s <16; s++)
		{
		 	if (subChanSelect[n][s] == 's')
		 	{
		 		activeChannelIndex++;
		 		if ((n==activeChannel)&&(s==activeSubChannel)) goto DONETHIS;
		 	}
		}
	}

DONETHIS:		
	if(activeChannelIndex) activeChannelIndex--;

	return 0;
}

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

int  chgComport(int panel, int control, int event,
					void *callbackData, int eventData1, int eventData2)
{
	int valComPort;

	/* prevent multiple entries */
	static char entryStat = 0;
	if(entryStat > 0) goto dupINSTANCE;
	entryStat++;

	switch (event)
	{
	
	case EVENT_LEFT_CLICK:
		miscSetup = NO_PENDING;   
	
	case EVENT_VAL_CHANGED :
		switch(acquireStat)
		{
			case IS_RUNNING:
			case IDLE:
				setMsgRuntime(" Cannot change com-port while running."
										"   ...click 'Stop' and try again.");
				SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 1);
				SetCtrlVal(hndMainPnl, PANEL_COMPORT, M201.comPort);
				break;
			default:
				GetCtrlVal(hndMainPnl, PANEL_COMPORT, &valComPort);
				setMsgRuntime(" com-port changed by user.");
				SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 0);
				M201.comPort = (short)valComPort;
				
				sprintf(comString, "COM-port: %2d", M201.comPort+1);
				SetCtrlVal(hndMainPnl, PANEL_SETUP_COM, comString);
				
				setupChanged = SETUP_CHANGED;
		}
	}

dupINSTANCE:
	entryStat = 0;

	return 0;
}

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

int  chgOperatingMode(int panel, int control, int event,
					void *callbackData, int eventData1, int eventData2)
{
	char n;
	/* prevent multiple entries */
	static char entryStat = 0;
	if(entryStat > 0) goto dupINSTANCE;
	entryStat++;

	if(event == EVENT_VAL_CHANGED)
	{
		switch(acquireStat)
		{
			case IS_RUNNING:
			case IDLE:
			
/* wait if polled mode conversion is in progress */
POLLED_CONV_WAIT:				
				if(opMode == POLLED_MODE)
				{
					/* wait if polled mode conversion is in progress */
					if(ConvPendingFlg)
					{
						if(RequestAnswer(&M201))
						{
							/* conversion in progress */
							goto POLLED_CONV_WAIT;
						}
					}
				}
				else
				{
					setMsgRuntime(" Cannot change operating mode while scanning."
										"  ...click 'Stop' and try again.");
					SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 1);
					SetCtrlVal(hndMainPnl, PANEL_OPERATINGMODE, opMode);
					goto dupINSTANCE;
				}
		 
			default:
			
				acquireStat = NOT_RUNNING;
				
				setMsgRuntime(" operating mode changed by user");
				SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 0);

				acquireStat = NOT_RUNNING;
				SetCtrlAttribute(hndMainPnl, PANEL_STAT, ATTR_ON_COLOR, VAL_RED);
				SetCtrlAttribute(hndMainPnl, PANEL_STAT, ATTR_LABEL_TEXT, "- stopped");
				DisplayPanel (hndMainPnl);

				ResetTextBox(hndMainPnl, PANEL_POLL_DISPLAY, "");

				GetCtrlVal(hndMainPnl, PANEL_OPERATINGMODE, &modeType );

				if(modeType == 0)
				{
					opMode = POLLED_MODE;

					SetCtrlAttribute(hndMainPnl, PANEL_SELF_CAL_BAK, ATTR_VISIBLE, 0);
					SetCtrlAttribute(hndMainPnl, PANEL_SELFCALIBRATING, ATTR_VISIBLE, 0);
					SetCtrlAttribute(hndMainPnl, PANEL_WAVEFORM, ATTR_VISIBLE, 0);
					SetCtrlAttribute(hndMainPnl, PANEL_X_AXIS_RANGE, ATTR_VISIBLE, 0);
					SetCtrlAttribute(hndMainPnl, PANEL_Y_AXIS_RANGE_POS, ATTR_VISIBLE, 0);
					SetCtrlAttribute(hndMainPnl, PANEL_Y_AXIS_RANGE_NEG, ATTR_VISIBLE, 0);
					SetCtrlAttribute(hndMainPnl, PANEL_SCAN_HDR, ATTR_VISIBLE, 0);
					SetCtrlAttribute(hndMainPnl, PANEL_SCAN_DISPLAY, ATTR_VISIBLE, 0);
					SetCtrlAttribute(hndMainPnl, PANEL_BUFF_HDR, ATTR_VISIBLE, 0);
					/* SetCtrlAttribute(hndMainPnl, PANEL_SCAN_DISPLAY2, ATTR_VISIBLE, 0); */
					SetCtrlAttribute(hndMainPnl, PANEL_BUFF_STAT_LED, ATTR_VISIBLE, 0);
					SetCtrlAttribute(hndMainPnl, PANEL_ZOOM, ATTR_VISIBLE, 0);
					SetCtrlAttribute(hndMainPnl, PANEL_AUTOSCALE_X, ATTR_VISIBLE, 0);
					SetCtrlAttribute(hndMainPnl, PANEL_AUTOSCALE_Y, ATTR_VISIBLE, 0);
					SetCtrlAttribute(hndMainPnl, PANEL_AUTO_AXIS_FRAME, ATTR_VISIBLE, 0);
					SetCtrlAttribute(hndMainPnl, PANEL_POLL_DISPLAY, ATTR_VISIBLE, 1);
					SetCtrlAttribute(hndMainPnl, PANEL_POLL_HDR, ATTR_VISIBLE, 1);
					SetCtrlAttribute(hndMainPnl, PANEL_RESET_MAX_MIN, ATTR_VISIBLE, 1);
					SetCtrlAttribute(hndMainPnl, PANEL_POLL_LINE_INDICATE, ATTR_VISIBLE, 1);

					for(n = PANEL_C0; n <= PANEL_C15; n++)
						SetCtrlAttribute(hndMainPnl, n, ATTR_ON_COLOR, VAL_WHITE);
				
					/* Next Line Added so that checkscantime calculates scan inteval for polled mode */  
					M201.tScan = 0;            
				}
				
				if(modeType == 1)
				{
					M201.tScan = 0;

					opMode = SINGLE_SCAN_MODE;

					SetCtrlAttribute(hndMainPnl, PANEL_SELF_CAL_BAK, ATTR_VISIBLE, 0);
					SetCtrlAttribute(hndMainPnl, PANEL_SELFCALIBRATING, ATTR_VISIBLE, 0);
					SetCtrlAttribute(hndMainPnl, PANEL_WAVEFORM, ATTR_VISIBLE, 1);
					SetCtrlAttribute(hndMainPnl, PANEL_X_AXIS_RANGE, ATTR_VISIBLE, 1);
					SetCtrlAttribute(hndMainPnl, PANEL_Y_AXIS_RANGE_POS, ATTR_VISIBLE, 1);
					SetCtrlAttribute(hndMainPnl, PANEL_Y_AXIS_RANGE_NEG, ATTR_VISIBLE, 1);
					SetCtrlAttribute(hndMainPnl, PANEL_SCAN_HDR, ATTR_VISIBLE, 1);
					SetCtrlAttribute(hndMainPnl, PANEL_SCAN_DISPLAY, ATTR_VISIBLE, 1);
					SetCtrlAttribute(hndMainPnl, PANEL_BUFF_HDR, ATTR_VISIBLE, 1);
					/* SetCtrlAttribute(hndMainPnl, PANEL_SCAN_DISPLAY2, ATTR_VISIBLE, 1); */
					SetCtrlAttribute(hndMainPnl, PANEL_BUFF_STAT_LED, ATTR_VISIBLE, 1);
					SetCtrlAttribute(hndMainPnl, PANEL_ZOOM, ATTR_VISIBLE, 1);
					SetCtrlAttribute(hndMainPnl, PANEL_AUTOSCALE_X, ATTR_VISIBLE, 1);
					SetCtrlAttribute(hndMainPnl, PANEL_AUTOSCALE_Y, ATTR_VISIBLE, 1);
					SetCtrlAttribute(hndMainPnl, PANEL_AUTO_AXIS_FRAME, ATTR_VISIBLE, 1);
 					SetCtrlAttribute(hndMainPnl, PANEL_POLL_DISPLAY, ATTR_VISIBLE, 0);
					SetCtrlAttribute(hndMainPnl, PANEL_POLL_HDR, ATTR_VISIBLE, 0);
					SetCtrlAttribute(hndMainPnl, PANEL_RESET_MAX_MIN, ATTR_VISIBLE, 0);
					SetCtrlAttribute(hndMainPnl, PANEL_POLL_LINE_INDICATE, ATTR_VISIBLE, 0);
					
					SetCtrlVal(hndMainPnl, PANEL_C0 + (M201.singleChan & 0x0f), 1);
					SetCtrlVal(hndMainPnl, PANEL_CHANNELSELECT, M201.singleChan >> 4);
					M201.channel = M201.singleChan >> 4;
				}
				
				if(modeType == 2)
				{
					M201.tScan = 2;

					opMode = MULTI_SCAN_MODE;

					SetCtrlAttribute(hndMainPnl, PANEL_SELF_CAL_BAK, ATTR_VISIBLE, 0);
					SetCtrlAttribute(hndMainPnl, PANEL_SELFCALIBRATING, ATTR_VISIBLE, 0);
					SetCtrlAttribute(hndMainPnl, PANEL_WAVEFORM, ATTR_VISIBLE, 1);
					SetCtrlAttribute(hndMainPnl, PANEL_X_AXIS_RANGE, ATTR_VISIBLE, 1);
					SetCtrlAttribute(hndMainPnl, PANEL_Y_AXIS_RANGE_POS, ATTR_VISIBLE, 1);
					SetCtrlAttribute(hndMainPnl, PANEL_Y_AXIS_RANGE_NEG, ATTR_VISIBLE, 1);
					SetCtrlAttribute(hndMainPnl, PANEL_SCAN_HDR, ATTR_VISIBLE, 1);
					SetCtrlAttribute(hndMainPnl, PANEL_SCAN_DISPLAY, ATTR_VISIBLE, 1);
					SetCtrlAttribute(hndMainPnl, PANEL_BUFF_HDR, ATTR_VISIBLE, 1);
					/* SetCtrlAttribute(hndMainPnl, PANEL_SCAN_DISPLAY2, ATTR_VISIBLE, 0); */
					SetCtrlAttribute(hndMainPnl, PANEL_BUFF_STAT_LED, ATTR_VISIBLE, 1);
					SetCtrlAttribute(hndMainPnl, PANEL_ZOOM, ATTR_VISIBLE, 1);
					SetCtrlAttribute(hndMainPnl, PANEL_AUTOSCALE_X, ATTR_VISIBLE, 1);
					SetCtrlAttribute(hndMainPnl, PANEL_AUTOSCALE_Y, ATTR_VISIBLE, 1);
					SetCtrlAttribute(hndMainPnl, PANEL_AUTO_AXIS_FRAME, ATTR_VISIBLE, 1);
					SetCtrlAttribute(hndMainPnl, PANEL_POLL_DISPLAY, ATTR_VISIBLE, 0);
					SetCtrlAttribute(hndMainPnl, PANEL_POLL_HDR, ATTR_VISIBLE, 0);
					SetCtrlAttribute(hndMainPnl, PANEL_RESET_MAX_MIN, ATTR_VISIBLE, 0);
					SetCtrlAttribute(hndMainPnl, PANEL_POLL_LINE_INDICATE, ATTR_VISIBLE, 0);
					setActiveSubChan();
				}

				if(modeType == 3)
				{
					M201.tScan = 2;

					opMode = MULTI_SCAN_CAL_MODE;

					SetCtrlAttribute(hndMainPnl, PANEL_SELF_CAL_BAK, ATTR_VISIBLE, 1);
					SetCtrlAttribute(hndMainPnl, PANEL_SELFCALIBRATING, ATTR_VISIBLE, 1);
					SetCtrlAttribute(hndMainPnl, PANEL_WAVEFORM, ATTR_VISIBLE, 1);
					SetCtrlAttribute(hndMainPnl, PANEL_X_AXIS_RANGE, ATTR_VISIBLE, 1);
					SetCtrlAttribute(hndMainPnl, PANEL_Y_AXIS_RANGE_POS, ATTR_VISIBLE, 1);
					SetCtrlAttribute(hndMainPnl, PANEL_Y_AXIS_RANGE_NEG, ATTR_VISIBLE, 1);
					SetCtrlAttribute(hndMainPnl, PANEL_SCAN_HDR, ATTR_VISIBLE, 1);
					SetCtrlAttribute(hndMainPnl, PANEL_SCAN_DISPLAY, ATTR_VISIBLE, 1);
					SetCtrlAttribute(hndMainPnl, PANEL_BUFF_HDR, ATTR_VISIBLE, 1);
					/* SetCtrlAttribute(hndMainPnl, PANEL_SCAN_DISPLAY2, ATTR_VISIBLE, 0);*/
					SetCtrlAttribute(hndMainPnl, PANEL_BUFF_STAT_LED, ATTR_VISIBLE, 1);
					SetCtrlAttribute(hndMainPnl, PANEL_ZOOM, ATTR_VISIBLE, 1);
					SetCtrlAttribute(hndMainPnl, PANEL_AUTOSCALE_X, ATTR_VISIBLE, 1);
					SetCtrlAttribute(hndMainPnl, PANEL_AUTOSCALE_Y, ATTR_VISIBLE, 1);
					SetCtrlAttribute(hndMainPnl, PANEL_AUTO_AXIS_FRAME, ATTR_VISIBLE, 1);
					SetCtrlAttribute(hndMainPnl, PANEL_POLL_DISPLAY, ATTR_VISIBLE, 0);
					SetCtrlAttribute(hndMainPnl, PANEL_POLL_HDR, ATTR_VISIBLE, 0);
					SetCtrlAttribute(hndMainPnl, PANEL_RESET_MAX_MIN, ATTR_VISIBLE, 0);
					SetCtrlAttribute(hndMainPnl, PANEL_POLL_LINE_INDICATE, ATTR_VISIBLE, 0);
					setActiveSubChan();
				}
		}
	}

	setMainPnlCtrls();

dupINSTANCE:
	entryStat = 0;

	return 0;
}

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

int  chgPolarityType(int panel, int control, int event,
					void *callbackData, int eventData1, int eventData2)
{
	int polarityType = 0;

	/* prevent multiple entries */
	static char entryStat = 0;
	if(entryStat > 0) goto dupINSTANCE;
	entryStat++;

	switch (event)
	{
		case EVENT_LEFT_CLICK:
			miscSetup = NO_PENDING;

		case EVENT_VAL_CHANGED :

			GetCtrlVal(hndMainPnl, PANEL_POLARITY_TYPE, &polarityType);

			switch(acquireStat)
			{
				case IS_RUNNING:
				case IDLE:

					if(opMode == POLLED_MODE)
					{
						if(ConvPendingFlg)
						{
							if(SendCancel())
							{
								setMsgRuntime(" send-cancel timeout error!");
								SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 1);
							  	goto dupINSTANCE;
							}
						}
					}

					M201.biPolar = (short)polarityType;
					if(M201.biPolar)
						SetCtrlVal(hndMainPnl, PANEL_SETUP_INPUT_RANGE, 
									"Input Range:  bi-polar");
					else
						SetCtrlVal(hndMainPnl, PANEL_SETUP_INPUT_RANGE, 
									"Input Range:  uni-polar");
						stDv=0; rmsBits=0; sdTot = 0; sdAvg=0; sdCount=1;
						SendADMode(&M201);
						SysCal(&M201);
						SetChanCode(&M201);

				default:
					M201.biPolar = (short)polarityType;
					if(M201.biPolar)
						SetCtrlVal(hndMainPnl, PANEL_SETUP_INPUT_RANGE, 
									"Input Range:  bi-polar");
					else
						SetCtrlVal(hndMainPnl, PANEL_SETUP_INPUT_RANGE, 
									"Input Range:  uni-polar");
			}

			if(M201.biPolar)
			SetAxisRange(hndMainPnl, PANEL_WAVEFORM, VAL_MANUAL, 0, pointXVal,
							 VAL_MANUAL, pointYValNeg, pointYValPos);
			else
			SetAxisRange(hndMainPnl, PANEL_WAVEFORM, VAL_MANUAL, 0, pointXVal,
							VAL_MANUAL, fabs(pointYValNeg), fabs(pointYValPos));
			
			if(M201.biPolar)
				SetAxisRange(hndMainPnl, PANEL_WAVEFORM, VAL_MANUAL, 0, pointXVal, 
	    							VAL_MANUAL, pointYValNeg, pointYValPos);
			else				
				SetAxisRange(hndMainPnl, PANEL_WAVEFORM, VAL_MANUAL, 0, pointXVal, 
								VAL_MANUAL, 0, 5);
				
			setMsgRuntime(" polarity type changed by user.");
			SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 0);
			setupChanged = SETUP_CHANGED;
  }

dupINSTANCE:
	entryStat = 0;

	return 0;
	
}

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

int  chgScanInterval(int panel, int control, int event,
					void *callbackData, int eventData1, int eventData2)
{
	int valChannel;
	int i, n;
	char cc[6];
	double curScanIntMax;
	char scanDispBuff[80];

	/* prevent multiple entries */
	static char entryStat = 0;
	if(entryStat > 0) goto dupINSTANCE;
	entryStat++;

	switch (event)
	{
	case EVENT_LEFT_CLICK:
	
	case EVENT_VAL_CHANGED :
		switch(acquireStat)
		{
			case IS_RUNNING:
			case IDLE:
				if(opMode != POLLED_MODE)
				{
					setMsgRuntime(" Cannot change Scan Interval while running."
										" ...click 'Stop' and try again.");
					SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 1);
					SetCtrlVal(hndMainPnl, PANEL_SCANINTERVAL, M201.scanInterval);
					break;
				}

			default:
				GetCtrlVal(hndMainPnl, PANEL_SCANINTERVAL, &requestedScanInterval);
	
				/*initialize control code array and calculate total number of points per scan */
				M201.numChannels = 0;
  				for (n = 0; n <= 5; n++)    
  				{
	 				if(M201.chan[n] != 0xf0)
	 				{
	 					cc[n] = ((M201.chan[n] & 0x0f) - (M201.chan[n] >> 4)) + 1;
	 					/*figure total number of channels/scan */
	 					M201.numChannels += cc[n]; 
	 				}
  				}
				
				switch(opMode)
				{
					case SINGLE_SCAN_MODE: 
						M201.tScan = 0; 
						break;
					case MULTI_SCAN_MODE: 
						M201.tScan = 1; 
						break;
					case MULTI_SCAN_CAL_MODE: 
						M201.tScan = 2;
						break;
				}
				
				i = CheckScanTime(&M201, &maxTime, &minTime);
				switch(i)
				{
					case 0:
						M201.scanInterval = requestedScanInterval;
						SetCtrlVal(hndMainPnl, PANEL_SCAN_INTERVAL, M201.scanInterval);
						sprintf(scanIntString, "Scan Interval:  %7.4lf", M201.scanInterval);
						SetCtrlVal(hndMainPnl, PANEL_SETUP_SCAN_INT, scanIntString);
						setMsgRuntime(" Scan Interval changed by user.");
						SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 0);
						doSignonFlg = 1;
						break;
						
					case 1:
						sprintf(scanIntString, " Scan Interval must be between "
								"%7.4lf-seconds and %7.0lf-seconds", minTime, maxTime);
						setMsgRuntime(scanIntString);
						SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 1);
						SetCtrlVal(hndMainPnl, PANEL_SCAN_INTERVAL, M201.scanInterval);
						break;
				}
		}
	}

dupINSTANCE:
	entryStat = 0;

	return 0;
}

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

int  chgScanIntervalSetup(int panel, int control, int event,
					void *callbackData, int eventData1, int eventData2)
{
	int valChannel;
	int i;
	double scanIntervalMaxTemp;
	double scanIntervalMinTemp;
	
	char tempBuff[80];

	/* prevent multiple entries */
	static char entryStat = 0;
	if(entryStat > 0) goto dupINSTANCE;
	entryStat++;

	
	/* if((eventData1 != 1280) && (event != EVENT_COMMIT)) */
	if((eventData1 == 1280) || (event == EVENT_COMMIT)) 
	{
	
	switch(acquireStat)
	{
		case IS_RUNNING:
		case IDLE:
			if(opMode != POLLED_MODE)
			{
				setMsgRuntime(" Cannot change Scan Interval while running."
									" ...click 'Stop' and try again.");
				SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 1);
				SetCtrlVal(hndMainPnl, PANEL_SCAN_INTERVAL, &M201.scanInterval);
				sprintf(scanIntString, "Scan Interval:  %7.4lf", M201.scanInterval);
				SetCtrlVal(hndMainPnl, PANEL_SETUP_SCAN_INT, scanIntString);

				if(eventData1 == 1280)
					miscSetup = NO_PENDING;
				break;
			}

		default:
			if(eventData1 == 1280)
			{
				SetCtrlAttribute(hndMainPnl, PANEL_SCAN_INTERVAL, ATTR_VISIBLE, 0);
				SetCtrlAttribute(hndMainPnl, PANEL_SETUP_NOTICE_3, ATTR_VISIBLE, 0);
				goto dupINSTANCE;
			}
			
			GetCtrlVal(hndMainPnl, PANEL_SCAN_INTERVAL, &requestedScanInterval);
			
			if (opMode == POLLED_MODE) M201.tScan = 0;
			i = CheckScanTime(&M201, &maxTime, &minTime);
			miscSetup = NO_PENDING;
			switch(i)
			{
				case 0:
					M201.scanInterval = requestedScanInterval;
					SetCtrlVal(hndMainPnl, PANEL_SCAN_INTERVAL, M201.scanInterval);

					GetCtrlAttribute(hndMainPnl, PANEL_SCANINTERVAL, ATTR_MAX_VALUE,
							&scanIntervalMaxTemp);
							
					if(scanIntervalMaxTemp < M201.scanInterval)
					{
						SetCtrlVal(hndMainPnl, PANEL_SCAN_INT_MAX, M201.scanInterval);
						SetCtrlAttribute(hndMainPnl, PANEL_SCANINTERVAL, ATTR_MAX_VALUE,
									M201.scanInterval);
						ProcessSystemEvents();
				
						chgScanIntervalMax(hndMainPnl, PANEL_SCAN_INT_MAX, 
											EVENT_VAL_CHANGED, 0, 0, 0);
				
					}
					
					GetCtrlAttribute(hndMainPnl, PANEL_SCANINTERVAL, ATTR_MIN_VALUE,
							&scanIntervalMinTemp);
							
					if(scanIntervalMaxTemp > M201.scanInterval)
					{
						SetCtrlVal(hndMainPnl, PANEL_SCAN_INT_MAX, M201.scanInterval);
						SetCtrlAttribute(hndMainPnl, PANEL_SCANINTERVAL, ATTR_MIN_VALUE,
							M201.scanInterval);
						ProcessSystemEvents();
				
						chgScanIntervalMax(hndMainPnl, PANEL_SCAN_INT_MAX, EVENT_VAL_CHANGED,
							0, 0, 0);
					}
					
					SetCtrlVal(hndMainPnl, PANEL_SCANINTERVAL, M201.scanInterval); 
					sprintf(scanIntString, "Scan Interval:  %7.4lf", M201.scanInterval);
					SetCtrlVal(hndMainPnl, PANEL_SETUP_SCAN_INT, scanIntString);
					setMsgRuntime(" Scan Interval changed by user.");
					SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 0);
					if(eventData1 == 1280)
						miscSetup = NO_PENDING;
					break;
						
				case 1:
					sprintf(scanIntString, " Scan Interval must be between "
							"%7.4lf-seconds and %7.0lf-seconds", minTime, maxTime);
					setMsgRuntime(scanIntString);
					SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 1);
					SetCtrlVal(hndMainPnl, PANEL_SCAN_INTERVAL, M201.scanInterval);
					break;
			}
	}
	}

dupINSTANCE:
	entryStat = 0;

	return 0;
}

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

int  chgScanIntervalMax(int panel, int control, int event,
					void *callbackData, int eventData1, int eventData2)
{
	char tempBuff[40];
	double curScanIntMax2 = 1.000;
	double curScanIntMin;

	/* prevent multiple entries */
	static char entryStat = 0;
	if(entryStat > 0) goto dupINSTANCE;
	entryStat++;

	GetCtrlVal(hndMainPnl, PANEL_SCAN_INT_MAX, &curScanIntMax2);

	switch (event)
	{
	case EVENT_VAL_CHANGED:
		switch(acquireStat)
		{
			case IS_RUNNING:
				if(opMode != POLLED_MODE)
				{
					setMsgRuntime(" Cannot change this scale while running"
										" ...click 'Stop' and try again.");
					SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 1);
					SetCtrlVal(hndMainPnl, PANEL_SCAN_INT_MAX, curScanIntMax);
					break;
				}

			default:

				SetCtrlAttribute(hndMainPnl, PANEL_SCANINTERVAL,
													ATTR_MAX_VALUE, curScanIntMax2);
				curScanIntMax = curScanIntMax2;
				setMsgRuntime(" Scan Interval  MAX  setting changed by user.");
				SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 0);

				if(curScanIntMax2 > 60)
				{
					if(M201.scanInterval < 1.0)
					{
						SetCtrlVal(hndMainPnl, PANEL_SCANINTERVAL, 1.0);
						chgScanInterval(hndMainPnl, PANEL_SCANINTERVAL, EVENT_VAL_CHANGED,
								(void*) 0, 1, 1);
					}
					SetCtrlAttribute(hndMainPnl, PANEL_SCANINTERVAL,
							ATTR_MIN_VALUE, 1.0);

					SetCtrlAttribute(hndMainPnl, PANEL_SCANINTERVAL,
							ATTR_PRECISION, 0);
					/* SetCtrlVal(hndMainPnl, PANEL_SCAN_INT_TYPE, "- minutes"); */

					setMsgRuntime(" Scan Interval reset to 1 second due to "
											"scan interval  MAX  setting");
					SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 1);
				}
				else
				{
					SetCtrlAttribute(hndMainPnl, PANEL_SCANINTERVAL,
							ATTR_MIN_VALUE, .0083);
					SetCtrlAttribute(hndMainPnl, PANEL_SCANINTERVAL,
							ATTR_MAX_VALUE,  curScanIntMax2);
					SetCtrlVal(hndMainPnl, PANEL_SCAN_INT_TYPE, "- seconds");

					SetCtrlAttribute(hndMainPnl, PANEL_SCANINTERVAL,
							ATTR_PRECISION, 4);

					if(curScanIntMax2 < M201.scanInterval)
					{
						SetCtrlAttribute(hndMainPnl, PANEL_SCANINTERVAL,
								ATTR_MIN_VALUE, curScanIntMax2 / 1.25);
						M201.scanInterval = curScanIntMax2;

						sprintf (tempBuff,"%7.4lf", M201.scanInterval);

						while(strlen(tempBuff) < 7)
						{
							strcat(tempBuff, "0");
						}

						SetCtrlVal(hndMainPnl, PANEL_SCANINTERVAL, curScanIntMax2);
						setMsgRuntime(" Scan Interval reset to current scan"
											"interval  MAX setting");
						SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 1);
						SetCtrlAttribute(hndMainPnl, PANEL_SCANINTERVAL,
								ATTR_MAX_VALUE, curScanIntMax2 * 1.25);
					}
				}
		}
	}

dupINSTANCE:
	entryStat = 0;

	return 0;
}

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

int  chgCutoffFreq(int panel, int control, int event,
					void *callbackData, int eventData1, int eventData2)
{
	static float curCutOffFreq;
	int activeCtrl;
	/* prevent multiple entries */
	static char entryStat = 0;
	if(entryStat > 0) goto dupINSTANCE;
	entryStat++;

    
   /* eventData1 == 1280 whenever ENTER key is pressed */
   /* event == EVENT_COMMIT any time any value is entered, even before <ENTER> */
   if((eventData1 != 1280) && (event != EVENT_COMMIT))
   		goto dupINSTANCE;
   		
	GetCtrlVal(hndMainPnl, PANEL_CUT_OFF_FREQ, &curCutOffFreq);
	
	M201.rate = curCutOffFreq * 4;
			
	sprintf(cutOffFreqString, "Cut-off freq: %7.2lf", curCutOffFreq);
	SetCtrlVal(hndMainPnl, PANEL_SETUP_CUT_OFF, cutOffFreqString);
			
	setMsgRuntime(" current cut-off frequency changed by user.");
	SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 0);
	setupChanged = SETUP_CHANGED;
	if(eventData1 == 1280) miscSetup = NO_PENDING;
	
	switch(acquireStat)
	{
		case IS_RUNNING:
		case IDLE:
		
			if(opMode == POLLED_MODE)
			{
				if(ConvPendingFlg)
				{
					if(SendCancel())
					{
						setMsgRuntime(" send-cancel timeout error!");
						SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 1);
						goto dupINSTANCE;
					}
				}
				
				SendADMode(&M201); 
				SysCal(&M201); 
				SetChanCode(&M201);
				stDv=0; rmsBits=0; sdTot = 0; sdAvg=0; sdCount=1;
			}
	}

dupINSTANCE:
	entryStat = 0;

	return 0;
}

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

int  ledStat(int panel, int control, int event,
					void *callbackData, int eventData1, int eventData2)
{
	/* prevent multiple entries */
	static char entryStat = 0;
	if(entryStat > 0) goto dupINSTANCE;
	entryStat++;

dupINSTANCE:
	entryStat = 0;

	return 0;
}

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

int  msgRuntime(int panel, int control, int event,
					void *callbackData, int eventData1, int eventData2)
{
	/* prevent multiple entries */
	static char entryStat = 0;
	if(entryStat > 0) goto dupINSTANCE;
	entryStat++;

dupINSTANCE:
	entryStat = 0;

	return 0;
}

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

int setMsgRuntime(char* msg)
{
	ResetTextBox(hndMainPnl, PANEL_MSG_RUNTIME, msg);
	DisplayPanel (hndMainPnl);  

	return 0;
}

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

int  pauseMainPnl(int panel, int control, int event,
				void *callbackData, int eventData1, int eventData2)
{
	/* prevent multiple entries */
	static char entryStat = 0;
	if(entryStat > 0) goto dupINSTANCE;
	entryStat++;

	switch (event) {
		case EVENT_LEFT_CLICK :

			miscSetup = NO_PENDING;
			
			ProcessSystemEvents();
			
			SetCtrlAttribute(hndMainPnl, PANEL_COMPORT, ATTR_VISIBLE, 0);
			SetCtrlAttribute(hndMainPnl, PANEL_BAUDRATE, ATTR_VISIBLE, 0);
			SetCtrlAttribute(hndMainPnl, PANEL_CUT_OFF_FREQ, ATTR_VISIBLE, 0);
			SetCtrlAttribute(hndMainPnl, PANEL_POLARITY_TYPE, ATTR_VISIBLE, 0);
			SetCtrlAttribute(hndMainPnl, PANEL_FILTER, ATTR_VISIBLE, 0);
			SetCtrlAttribute(hndMainPnl, PANEL_AVERAGE, ATTR_VISIBLE, 0);
			SetCtrlAttribute(hndMainPnl, PANEL_WORD_LENGTH, ATTR_VISIBLE, 0);
			SetCtrlAttribute(hndMainPnl, PANEL_SCAN_INTERVAL, ATTR_VISIBLE, 0);

			if(acquireStat == IS_RUNNING)
			{
				if(ConvPendingFlg)
				{
					if(SendCancel())
					{
						setMsgRuntime(" send-cancel timeout error!");
						SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 1);
							 goto dupINSTANCE;
					}
				}
				
				M201.standBy = 1;
	 			SendADMode(&M201);
				setMsgRuntime(" standby mode");
				SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 0);
				acquireStat = IDLE;
				SetCtrlAttribute(hndMainPnl, PANEL_STAT, ATTR_ON_COLOR, VAL_YELLOW);
				SetCtrlAttribute(hndMainPnl, PANEL_STAT, ATTR_LABEL_TEXT, "- standby");
				SetCtrlAttribute(hndMainPnl, PANEL_PAUSE, ATTR_LABEL_TEXT, "__Resume");
				DisplayPanel (hndMainPnl);
				/*
				setupChanged = SETUP_CHANGED;
				flashAttention();
				*/
				goto dupINSTANCE;
			}

			else if(acquireStat == IDLE)
			{
				M201.standBy = 0;
	 			SendADMode(&M201);
				setMsgRuntime(" out of standby mode");
				SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 0);
				acquireStat = IS_RUNNING;
				SetCtrlAttribute(hndMainPnl, PANEL_STAT, ATTR_ON_COLOR, VAL_GREEN);
				SetCtrlAttribute(hndMainPnl, PANEL_STAT, ATTR_LABEL_TEXT, "- running");
				SetCtrlAttribute(hndMainPnl, PANEL_PAUSE, ATTR_LABEL_TEXT, "__Standby");
				DisplayPanel (hndMainPnl);
				/*
				setupChanged = SETUP_CHANGED;
				flashAttention();
				*/
			}
	}

dupINSTANCE:
	entryStat = 0;

	return 0;
}

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

int  stopMainPnl(int panel, int control, int event,
				void *callbackData, int eventData1, int eventData2)
{
	/* prevent multiple entries */
	static char entryStat = 0;
	if(entryStat > 0) goto dupINSTANCE;
	entryStat++;

	switch (event) {
		case EVENT_LEFT_CLICK :
			if((acquireStat == IDLE) || (acquireStat == IS_RUNNING))
			{
				if(M201.standBy == 1)
				{
					M201.standBy = 0;
	 				SendADMode(&M201);
	 			}
	 		}
		
			/*
			SetCtrlVal(hndMainPnl, PANEL_BUFF_STAT_LED, 0);
			*/
			miscSetup = NO_PENDING;
			ProcessSystemEvents();
			SetCtrlAttribute(hndMainPnl, PANEL_COMPORT, ATTR_VISIBLE, 0);
			SetCtrlAttribute(hndMainPnl, PANEL_BAUDRATE, ATTR_VISIBLE, 0);
			SetCtrlAttribute(hndMainPnl, PANEL_CUT_OFF_FREQ, ATTR_VISIBLE, 0);
			SetCtrlAttribute(hndMainPnl, PANEL_POLARITY_TYPE, ATTR_VISIBLE, 0);
			SetCtrlAttribute(hndMainPnl, PANEL_FILTER, ATTR_VISIBLE, 0);
			SetCtrlAttribute(hndMainPnl, PANEL_AVERAGE, ATTR_VISIBLE, 0);
			SetCtrlAttribute(hndMainPnl, PANEL_WORD_LENGTH, ATTR_VISIBLE, 0);
			SetCtrlAttribute(hndMainPnl, PANEL_SCAN_INTERVAL, ATTR_VISIBLE, 0);

			if(modeType != POLLED_MODE)
			{
				switch(acquireStat)
				{
					case IS_RUNNING:
					case IDLE:
						GetCtrlVal(hndMainPnl, PANEL_OPERATINGMODE, &modeType );
						if(modeType != POLLED_MODE)
						{
							acquireStat = NOT_RUNNING;
							hndStandbyPnl = LoadPanel (0, "standby.uir", STANDBY);
							DisplayPanel (hndStandbyPnl);
							SetCtrlAttribute(hndStandbyPnl, STANDBY_LOG_TXT, 
											ATTR_VISIBLE, 0);
							/* the rest of the "closing" code will be handled by
							   the closing of the scan routine, as long as a handle
							   to the standby panel is present
							*/
							goto dupINSTANCE;
						}
				}
			}
			
			acquireStat = NOT_RUNNING;
			SetCtrlAttribute(hndMainPnl, PANEL_STAT, ATTR_ON_COLOR, VAL_RED);
			SetCtrlAttribute(hndMainPnl, PANEL_PAUSE, ATTR_LABEL_TEXT, "__Standby");
			SetCtrlAttribute(hndMainPnl, PANEL_STAT, ATTR_LABEL_TEXT, "- stopped");
			setMsgRuntime(" Data Acquisition stopped.");
			SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 0);
	}

dupINSTANCE:
	entryStat = 0;

	return 0;
}

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

int  Shutdown(int panel, int control, int event,
				void *callbackData, int eventData1, int eventData2)
{
	/* prevent multiple entries */
	static char entryStat = 0;
	if(entryStat > 0) goto dupINSTANCE;
	entryStat++;

	if (event == EVENT_COMMIT)
	{
		miscSetup = NO_PENDING;
		ProcessSystemEvents();
		SetCtrlAttribute(hndMainPnl, PANEL_COMPORT, ATTR_VISIBLE, 0);
		SetCtrlAttribute(hndMainPnl, PANEL_BAUDRATE, ATTR_VISIBLE, 0);
		SetCtrlAttribute(hndMainPnl, PANEL_CUT_OFF_FREQ, ATTR_VISIBLE, 0);
		SetCtrlAttribute(hndMainPnl, PANEL_POLARITY_TYPE, ATTR_VISIBLE, 0);
		SetCtrlAttribute(hndMainPnl, PANEL_FILTER, ATTR_VISIBLE, 0);
		SetCtrlAttribute(hndMainPnl, PANEL_AVERAGE, ATTR_VISIBLE, 0);
		SetCtrlAttribute(hndMainPnl, PANEL_WORD_LENGTH, ATTR_VISIBLE, 0);
		SetCtrlAttribute(hndMainPnl, PANEL_SCAN_INTERVAL, ATTR_VISIBLE, 0);

		if(miscSetup != NO_PENDING) goto dupINSTANCE;
		
		switch(acquireStat)
		{
			case IS_RUNNING:
			case IDLE:
				GetCtrlVal(hndMainPnl, PANEL_OPERATINGMODE, &modeType );
				if(modeType != POLLED_MODE)
				{
					acquireStat = NOT_RUNNING;
					hndStandbyPnl = LoadPanel (0, "standby.uir", STANDBY);
					SetCtrlAttribute(hndStandbyPnl, STANDBY_LOG_TXT, 
											ATTR_VISIBLE, 0);
					DisplayPanel (hndStandbyPnl);
					exitFlag = 1;
					goto dupINSTANCE;
				}
		}
		
		if(openComFlag)					//7-30-98
		{								//7-30-98
			CloseCom(M201.comPort+1);  	//7-30-98
			openComFlag = 0;			//7-30-98
		}								//7-30-98
		if(hndLogfile)					//7-30-98
		{								//7-30-98
			fclose(hndLogfile);			//7-30-98
		}								//7-30-98
		
		miscSetup = NO_PENDING;
		acquireStat = NOT_RUNNING;
		QuitUserInterface(0);
		DiscardPanel(hndMainPnl);
		exit(1);
		
	}

dupINSTANCE:
	entryStat = 0;

	return(0);
}

/*----- END OF MAIN PANEL FUNCTIONS ---------*/
/*********************************************/

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

/****** WARNING PANEL FUNCTIONS **************/
/*-------------------------------------------*/

int setWarnPnl()
{
	if(!hndWarnPnl)
	{
		hndWarnPnl = LoadPanel (0, "warning.uir", NOTICE);
		DisplayPanel (hndWarnPnl);
		return 0;
	}
	else return 1;
}

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
/* N O T E :  NOT CURRENTLY USED!!! use to insert dynamic controls */

int cntlWarnPnl(BOOL show, int ID)
{
	if(!show)
		DiscardCtrl(hndWarnPnl, ID);
	return 0;
}

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

int textWarnPnl(BOOL button)
{
	if(hndWarnPnl)
	{
		if(!button)
			DiscardCtrl(hndWarnPnl, ERROR_QUIT);
		SetCtrlVal(hndWarnPnl, ERROR_TEXTMSG , msgWarnPnl);
		return(FALSE);
	}
	return(TRUE);
}

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

int dotWarnPnl(int num, double delay, BOOL destroy)
{
	int cnt;
	for (cnt = 0; cnt < num; cnt++)
	{
		Delay(delay);
		strcat(msgWarnPnl, " .");
		textWarnPnl(HIDE_BUTTON);
	}
	if(destroy)
	{
		DiscardPanel(hndWarnPnl);
		hndWarnPnl = 0;
	}
	return 0;
}

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

int dispWarnPnl()
{
		if(hndWarnPnl)
		{
			DisplayPanel (hndWarnPnl);
			return(TRUE);
		}
		else
			return(FALSE);
}

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

int  focusWarnPnl(int panel, int event, void *callbackData,
						int eventData1, int eventData2)
{
	/* prevent multiple entries */
	static char entryStat = 0;
	if(entryStat > 0) goto dupINSTANCE;
	entryStat++;

	switch (event) {
		  case EVENT_LEFT_CLICK :
		  	eventPendingFlg = EVENT_PENDING;
			break;
		  }

dupINSTANCE:
	entryStat = 0;

	return (0);
}


/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

int  fileWarnPnl(int panel, int control, int event,
				void *callbackData, int eventData1, int eventData2)
{
	/* prevent multiple entries */
	static char entryStat = 0;
	if(entryStat > 0) goto dupINSTANCE;
	entryStat++;

	 switch (event) {
		  case EVENT_LEFT_CLICK :

				SetCtrlAttribute(hndMainPnl, PANEL_FILE_OVERWRITE, ATTR_VISIBLE, 1);

				if(control == FILEWARN_FILE_OVERWRITE_YES)
				{
					SetCtrlVal(hndMainPnl, PANEL_FILE_OVERWRITE, OVERWRITE_ALL);
					fileOverwriteFlg = OVERWRITE_ALL;
					fileOverwritePrmpt = DO_OVERWRITE;
				}
				if (control == FILEWARN_FILE_OVERWRITE_NO)
				{
					SetCtrlVal(hndMainPnl, PANEL_FILE_OVERWRITE, OVERWRITE_PROMPT);
					fileOverwriteFlg = OVERWRITE_PROMPT;
					fileOverwritePrmpt = DONT_OVERWRITE;
				}

				DiscardPanel(hndFileWarnPnl);
				hndFileWarnPnl = 0;
				overwriteOnceFlg = 1;
		  }

dupINSTANCE:
	entryStat = 0;

	return (0);
}

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

int  closeWarnPnl(int panel, int control, int event,
				void *callbackData, int eventData1, int eventData2)
{
	/* prevent multiple entries */
	static char entryStat = 0;
	if(entryStat > 0) goto dupINSTANCE;
	entryStat++;

	if (event == EVENT_COMMIT)
	{
		DiscardPanel(hndWarnPnl);
		hndWarnPnl = 0;
	}

dupINSTANCE:
	entryStat = 0;

	return (0);
}

/*----- END OF WARINING PANEL FUNCTIONS -----*/
/*********************************************/

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

/****** STAT PANEL FUNCTIONS *****************/
/*-------------------------------------------*/

int setStatPnl()
{
	if(!existStatPnl)
	{
		hndStatPnl = LoadPanel (0, "config.uir", NOTICE);
		DisplayPanel (hndStatPnl);
		existStatPnl = TRUE;
		return 1;
	}
	else return 0;
}

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
/* N O T E :  NOT CURRENTLY USED!!! use to insert dynamic controls */
int cntlStatPnl(BOOL show, int ID)
{
	if(!show)
		DiscardCtrl(hndStatPnl, ID);
	return 1;
}

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

int textStatPnl(BOOL button)
{

	if(existStatPnl)
	{
		if(!button)
			DiscardCtrl(hndStatPnl, NOTICE_QUIT);
		SetCtrlVal(hndStatPnl, NOTICE_TEXTMSG , msgStatPnl);
		return(TRUE);
	}

	return(FALSE);
}

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

int dotStatPnl(int num, double delay, BOOL destroy)
{
	int cnt;
	for (cnt = 0; cnt < num; cnt++)
	{
		Delay(delay);
		strcat(msgStatPnl, " .");

		/* don't show OK button */
		textStatPnl(HIDE_BUTTON);
	}
	if(destroy)
	{
		/* tim NOTE get rid of all these and use only handles */
		existStatPnl = FALSE;
		DiscardPanel(hndStatPnl);
	}
	return 0;
}

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

int dispStatPnl()
{
		if(existStatPnl)
		{
			DisplayPanel (hndStatPnl);
			return(TRUE);
		}
		else
			return(FALSE);
}

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

int  focusStatPnl(int panel, int event, void *callbackData,
						int eventData1, int eventData2)
{
	/* prevent multiple entries */
	static char entryStat = 0;
	if(entryStat > 0) goto dupINSTANCE;
	entryStat++;

	 existStatPnl = TRUE;
	 switch (event) {
		  case EVENT_LEFT_CLICK :

				break;
		  }

dupINSTANCE:
	entryStat = 0;

	return (0);
}

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

int  closeStatPnl(int panel, int control, int event,
				void *callbackData, int eventData1, int eventData2)
{
	/* prevent multiple entries */
	static char entryStat = 0;
	if(entryStat > 0) goto dupINSTANCE;
	entryStat++;

	if (event == EVENT_COMMIT)
	{
		existStatPnl = FALSE;
		DiscardPanel(hndStatPnl);
	}

dupINSTANCE:
	entryStat = 0;

	return (0);
}

/*----- END OF STAT PANEL FUNCTIONS ---------*/
/*********************************************/

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

/****** READCONFIG FUNCTION ******************/
/*-------------------------------------------*/

short ReadConfig()
{
	char tmpbuf[80];
	FILE *rCfg;
	int hndFile = 0;
	long fSize = 0;

	if(GetFileInfo("M201_CVI.CFG", &fSize))
	if((hndFile = OpenFile("M201_CVI.CFG", 1, 0, 1)) != NULL)
	{
		setMsgRuntime(" Reading file: M201_CVI.CFG .");
		SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 0);
		DisplayPanel (hndMainPnl);
		Delay(.125);
		ReadLine(hndFile, tmpbuf,20);
		sscanf(tmpbuf,"%d",&M201.TXQUEUESIZE);
		ReadLine(hndFile, tmpbuf,20);
		sscanf(tmpbuf,"%d",&M201.RXQUEUESIZE);
		ReadLine(hndFile, tmpbuf,20);
		sscanf(tmpbuf,"%hd",&M201.baud);
		ReadLine(hndFile, tmpbuf,20);
		sscanf(tmpbuf,"%hd",&M201.comPort);
		setMsgRuntime(" Reading file: M201_CVI.CFG .  .");
		DisplayPanel (hndMainPnl);
		Delay(.125);
		ReadLine(hndFile, tmpbuf,20);
		sscanf(tmpbuf,"%lf",&M201.scanInterval);
		ReadLine(hndFile, tmpbuf,20);
		sscanf(tmpbuf,"%hd",&M201.numChannels);
		ReadLine(hndFile, tmpbuf,20);
		sscanf(tmpbuf,"%d",&M201.average);
		ReadLine(hndFile, tmpbuf,20);
		sscanf(tmpbuf,"%hd",&M201.tScan);
		ReadLine(hndFile, tmpbuf,20);
		sscanf(tmpbuf,"%hd",&M201.chan[0]);
		setMsgRuntime(" Reading file: M201_CVI.CFG .  .  .");
		DisplayPanel (hndMainPnl);
		Delay(.125);
		ReadLine(hndFile, tmpbuf,20);
		sscanf(tmpbuf,"%hd",&M201.chan[1]);
		ReadLine(hndFile, tmpbuf,20);
		sscanf(tmpbuf,"%hd",&M201.chan[2]);
		ReadLine(hndFile, tmpbuf,20);
		sscanf(tmpbuf,"%hd",&M201.chan[3]);
		ReadLine(hndFile, tmpbuf,20);
		sscanf(tmpbuf,"%hd",&M201.chan[4]);
		setMsgRuntime(" Reading file: M201_CVI.CFG .  .  .  .");
		DisplayPanel (hndMainPnl);
		Delay(.125);
		ReadLine(hndFile, tmpbuf,20);
		sscanf(tmpbuf,"%hd",&M201.chan[5]);
		ReadLine(hndFile, tmpbuf,20);
		sscanf(tmpbuf,"%hd",&M201.singleChan);
		ReadLine(hndFile, tmpbuf,20);
		sscanf(tmpbuf,"%hd",&M201.channel);
		ReadLine(hndFile, tmpbuf,20);
		sscanf(tmpbuf,"%hd",&M201.subChan);
		setMsgRuntime(" Reading file: M201_CVI.CFG .  .  .  .  .");
		DisplayPanel (hndMainPnl);
		Delay(.125);
		ReadLine(hndFile, tmpbuf,20);
		sscanf(tmpbuf,"%hd",&M201.wordCnt);
		ReadLine(hndFile, tmpbuf,20);
		sscanf(tmpbuf,"%hd",&M201.biPolar);
		ReadLine(hndFile, tmpbuf,20);
		sscanf(tmpbuf,"%hd",&M201.filter);
		ReadLine(hndFile, tmpbuf,20);
		sscanf(tmpbuf,"%hd",&M201.gain);
		setMsgRuntime(" Reading file: M201_CVI.CFG .  .  .  .  .  .");
		DisplayPanel (hndMainPnl);
		Delay(.125);
		ReadLine(hndFile, tmpbuf,20);
		sscanf(tmpbuf,"%f",&M201.rate);
		ReadLine(hndFile, tmpbuf,20);
		sscanf(tmpbuf,"%hd",&M201.modeRegLo);
		ReadLine(hndFile, tmpbuf,20);
		sscanf(tmpbuf,"%hd",&M201.modeRegMid);
		ReadLine(hndFile, tmpbuf,20);
		setMsgRuntime(" Reading file: M201_CVI.CFG .  .  .  .  .  .  .");
		DisplayPanel (hndMainPnl);
		Delay(.125);
		sscanf(tmpbuf,"%hd",&M201.modeRegHi);
		ReadLine(hndFile, tmpbuf,20);
		sscanf(tmpbuf,"%hd",&localAvg);
		setMsgRuntime(" Configuration successfully loaded from:   M201_CVI.CFG.");
		DisplayPanel (hndMainPnl);
		CloseFile(hndFile);
		return 1;
	}
	setDefaults(TRUE);
	return 0;
}

/*------ END OF READCONFIG FUNCTION ---------*/
/*********************************************/

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

/****** SETDEFAULTS FUNCTION *****************/
/*-------------------------------------------*/

short setDefaults(BOOL dispDlg)
{
	if(dispDlg)
	{
		setStatPnl();
		strcpy(msgStatPnl, "\nUnable to read configuration file:\n\n"
								"M201_CVI.CFG\n\n"
								"Loading default values");
		textStatPnl(SHOW_BUTTON);
		dispStatPnl();
	}
	M201.TXQUEUESIZE = 1;
	M201.RXQUEUESIZE = 1024;
	M201.baud = 0;
	M201.comPort = 0;
	M201.filter = 2;
	M201.gain = 1;
	M201.rate = 10;
	M201.wordCnt = 3;
	M201.biPolar = 1;
	M201.average = 1;
	M201.scanInterval = 1;
	M201.numChannels = 6;
	M201.chan[0]= 0;
	M201.chan[1]= 0;
	M201.chan[2]= 0;
	M201.chan[3]= 0;
	M201.chan[4]= 0;
	M201.chan[5]= 0;
	M201.singleChan = 0;
	M201.tScan = 0;
	M201.channel = 0;
	M201.subChan = 0;
	localAvg = 1;
	setMainPnlCtrls();

	return 0;
}

/*------ END OF SETDEFAULTS FUNCTION --------*/
/*********************************************/

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

/****** WRITECONFIG FUNCTION ******************/
/*-------------------------------------------*/

short WriteConfig()
{
	FILE *wCfg;
	int i = 2;

	if ((wCfg = fopen("M201_CVI.CFG", "wt")) != NULL)
	{
		setMsgRuntime(" Writing file: M201_CVI.CFG .");
		SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 0);
		DisplayPanel (hndMainPnl);
		Delay(.125);
		fprintf(wCfg,"%d\n",M201.TXQUEUESIZE);
		fprintf(wCfg,"%d\n",M201.RXQUEUESIZE);
		fprintf(wCfg,"%hd\n",M201.baud);
		fprintf(wCfg,"%hd\n",M201.comPort);
		setMsgRuntime(" Writing file: M201_CVI.CFG .  .");
		DisplayPanel (hndMainPnl);
		Delay(.125);
		fprintf(wCfg,"%lf\n",M201.scanInterval);
		fprintf(wCfg,"%hd\n",M201.numChannels);
		fprintf(wCfg,"%d\n",M201.average);
		fprintf(wCfg,"%hd\n",M201.tScan);
		setMsgRuntime(" Writing file: M201_CVI.CFG .  .  .");
		DisplayPanel (hndMainPnl);
		Delay(.125);
		fprintf(wCfg,"%hd\n",M201.chan[0]);
		fprintf(wCfg,"%hd\n",M201.chan[1]);
		fprintf(wCfg,"%hd\n",M201.chan[2]);
		fprintf(wCfg,"%hd\n",M201.chan[3]);
		setMsgRuntime(" Writing file: M201_CVI.CFG .  .  .  .");
		DisplayPanel (hndMainPnl);
		Delay(.125);
		fprintf(wCfg,"%hd\n",M201.chan[4]);
		fprintf(wCfg,"%hd\n",M201.chan[5]);
		fprintf(wCfg,"%hd\n",M201.singleChan);
		fprintf(wCfg,"%hd\n",M201.channel);
		setMsgRuntime(" Writing file: M201_CVI.CFG .  .  .  .  .");
		DisplayPanel (hndMainPnl);
		Delay(.125);
		fprintf(wCfg,"%hd\n",M201.subChan);
		fprintf(wCfg,"%hd\n",M201.wordCnt);
		fprintf(wCfg,"%hd\n",M201.biPolar);
		fprintf(wCfg,"%hd\n",M201.filter);
		setMsgRuntime(" Writing file: M201_CVI.CFG .  .  .  .  .  .");
		DisplayPanel (hndMainPnl);
		Delay(.125);
		fprintf(wCfg,"%hd\n",M201.gain);
		fprintf(wCfg,"%f\n",M201.rate);
		fprintf(wCfg,"%hd\n",M201.modeRegLo);
		fprintf(wCfg,"%hd\n",M201.modeRegMid);
		setMsgRuntime(" Writing file: M201_CVI.CFG .  .  .  .  .  .  .");
		DisplayPanel (hndMainPnl);
		Delay(.125);
		fprintf(wCfg,"%hd\n",M201.modeRegHi);
		fprintf(wCfg,"%hd\n",localAvg);
		fclose(wCfg);
		return 1;
  }
  else
  {
		setStatPnl();
		strcpy(msgStatPnl, "\nUnable to write configuration file:\n\n"
								"M201_CVI.CFG\n\n");
		textStatPnl(SHOW_BUTTON);    /* write text to stat panel */
		dispStatPnl();
  }

  return 0;
}

/*------ END OF WRITECONFIG FUNCTION --------*/
/*********************************************/

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

/****** SETMAINCNTRLS FUNCTION ***************/
/*-------------------------------------------*/

int setMainPnlCtrls()
{
	long 						bauds[]={  /*  table for baud rate codes  */
								/* 0  */  9600,
								/* 1  */  4800,
								/* 2  */  2400,
								/* 3  */  1200,
								/* 4  */   600,
								/* 5  */   300};
	char tempBuff[80];
	int valChannel;

	int ctrlNum = 0;
	int cnt, cnt2, cntLow, cntHigh;

	SetCtrlVal(hndMainPnl, PANEL_BAUDRATE, M201.baud);
	sprintf(baudString, "BAUD:  %4d", bauds[M201.baud]);
	SetCtrlVal(hndMainPnl, PANEL_SETUP_BAUD, baudString);
	
	SetCtrlVal(hndMainPnl, PANEL_COMPORT, M201.comPort);
	sprintf(comString, "COM-port: %2d", M201.comPort+1);
	SetCtrlVal(hndMainPnl, PANEL_SETUP_COM, comString);
	
	sprintf(avgString, "Average: %5d", M201.average);
	SetCtrlVal(hndMainPnl, PANEL_SETUP_AVERAGE, avgString);
	
	if(M201.filter == 2)
	{
		sprintf(filterString, "Filter: 400 Hz");
		SetCtrlVal(hndMainPnl, PANEL_FILTER, 2);
	}
	
	if(M201.filter == 1)
	{
		sprintf(filterString, "Filter: 40 Hz");
		SetCtrlVal(hndMainPnl, PANEL_FILTER, 1);
	}
	
	if(M201.filter == 0)
	{
		SetCtrlVal(hndMainPnl, PANEL_FILTER, 0);
		sprintf(filterString, "Filter: 4 Hz");
	}
	
	SetCtrlVal(hndMainPnl, PANEL_SETUP_FILTER, filterString);
	sprintf(cutOffFreqString, "Cut-off freq: %7.2lf Hz", M201.rate / 4);
	SetCtrlVal(hndMainPnl, PANEL_SETUP_CUT_OFF, cutOffFreqString);
	SetCtrlVal(hndMainPnl, PANEL_CUT_OFF_FREQ, M201.rate / 4);
	
	if(M201.biPolar)
	{
		SetCtrlVal(hndMainPnl, PANEL_SETUP_INPUT_RANGE, "Input Range:   bi-polar");
		SetCtrlVal(hndMainPnl, PANEL_POLARITY_TYPE, 1);
	}
	else
	{
		SetCtrlVal(hndMainPnl, PANEL_SETUP_INPUT_RANGE, "Input Range:   uni-polar");
		SetCtrlVal(hndMainPnl, PANEL_POLARITY_TYPE, 0);
	}
	
	SetCtrlVal(hndMainPnl, PANEL_CHANNELSELECT, M201.channel);
	SetCtrlVal(hndMainPnl, PANEL_SCANINTERVAL, M201.scanInterval);
	SetCtrlVal(hndMainPnl, PANEL_SCAN_INTERVAL, M201.scanInterval);
	requestedScanInterval = M201.scanInterval;
	
	sprintf(scanIntString, "Scan Interval:  %7.4lf sec.", M201.scanInterval);
	SetCtrlVal(hndMainPnl, PANEL_SETUP_SCAN_INT, scanIntString);
	
	GetCtrlAttribute(hndMainPnl, PANEL_SCANINTERVAL,
								ATTR_MAX_VALUE, &curScanIntMax);

	if(curScanIntMax <= M201.scanInterval)
	{
		SetCtrlVal(hndMainPnl, PANEL_SCAN_INT_MAX, M201.scanInterval * 1.5);
		SetCtrlAttribute(hndMainPnl, PANEL_SCANINTERVAL,
								ATTR_MAX_VALUE, M201.scanInterval);
	}
	else
	{
		SetCtrlVal(hndMainPnl, PANEL_SCAN_INT_MAX, curScanIntMax);
	}

	GetCtrlVal(hndMainPnl, PANEL_OPERATINGMODE, &modeType);

	for(cnt = 0; cnt < 6; cnt++)
	{
		for(cnt2 = 0; cnt2 < 16; cnt2++)
			subChanSelect[cnt][cnt2] = 'c';
	}

	for(cnt = 0; cnt < 6; cnt++)
	{
		cntHigh = M201.chan[cnt] & 0x0f;
		cntLow = M201.chan[cnt] >> 4;
		for(;cntLow <= cntHigh ; cntLow++)
			subChanSelect[cnt][cntLow] = 's';
	}

	for(cnt = 0; cnt < 16; cnt ++)
	{
		SetCtrlVal(hndMainPnl, PANEL_C0 + cnt, 0);
	}

	if(modeType == POLLED_MODE)
	{
		SetCtrlVal(hndMainPnl, PANEL_C0 + M201.subChan, 1);
	}

	if(modeType == SINGLE_SCAN_MODE)
	{
		SetCtrlVal(hndMainPnl, PANEL_C0 + (M201.singleChan & 0x0f), 1);
		SetCtrlVal(hndMainPnl, PANEL_CHANNELSELECT, M201.singleChan >> 4);
	}

	if((modeType == MULTI_SCAN_MODE) || (modeType == MULTI_SCAN_CAL_MODE))
	{
		for(cnt = 0; cnt < 16; cnt++)
			if(subChanSelect[M201.channel][cnt] == 's')
			{
				SetCtrlVal(hndMainPnl, PANEL_C0 + cnt, 1);
			}
	}

	GetCtrlVal(hndMainPnl, PANEL_X_AXIS_RANGE, &pointXVal);
	GetCtrlVal(hndMainPnl, PANEL_Y_AXIS_RANGE_POS, &pointYValPos);
	GetCtrlVal(hndMainPnl, PANEL_Y_AXIS_RANGE_NEG, &pointYValNeg);

	return 0;
}

/*------ END OF SETMAINCTRLS FUNCTION -------*/
/*********************************************/

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

/****** INIT_201 FUNCTION ********************/
/*-------------------------------------------*/
/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*
	TIM NOTE: do something else with these !!!
*/
FILE 	       			*out;
int 	i, n, p_row = 14, startCC, endCC, Ch;

char 	fileName[12], tmpbuf[180], scanBuff[80],
		fileBuff[80], fileBuffExt[1181];
		
char* 	SignOnRetMsg;

short 	receiveError, checkSum = 1, cc[6];

int 	hndPlotLine = 0, curInQueue = 0;

long 	rawCount, scanCnt;
	 /* table for baud rate codes */
long 					bauds[]={
							/* 0  */  9600,
							/* 1  */  4800,
							/* 2  */  2400,
							/* 3  */  1200,
							/* 4  */   600,
							/* 5  */   300};

double voltage, max=-12000, min=12000, scanNum, doEventsWait = 0;


// 10-28-98 ======================================================
//double scanVoltData[1120]
// dynamically make array this size->pointXVal
double *scanVoltData;
//================================================================


int 
init_201(void)
{
	char initBuff[150], initCnt = 0;
	short	localAvg = 1;
	int i2 = 0, cnt = 0, s, n, temp, temp1, tempMOD = 0;
	double maxTime, minTime, graph_X = 0, graph_X2 = 0;
	scanNum = 0;
	curInQueue = 0;
	
	if((opMode == POLLED_MODE) && (acquireStat == IS_RUNNING))
	{
		goto POLLED;
	}

	if(((opMode == SINGLE_SCAN_MODE)
		|| (opMode == MULTI_SCAN_MODE)
		|| (opMode == MULTI_SCAN_CAL_MODE))
		&& (acquireStat == IS_RUNNING))
	{
		goto SCAN;
	}
	
	/*model 202 specific element (reserved) */
	M201.timeBaseCnt = -1;

	/*set to not in standby */
	M201.standBy = 0;

	/*set to awake */
	M201.sleeping = 0;

	if(!doSignonFlg) goto NO_SIGNON;
	
	setMsgRuntime(" Initializing M201 .");
	SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 0);
	
	if(SignOn(&M201, setMsgRuntimePtr) != NULL)
	{
		doSignonFlg = 1;
		setWarnPnl();
		strcpy(msgWarnPnl, errorMsg201CVI);
		textWarnPnl(SHOW_BUTTON);
		dispWarnPnl();
		return (1);
	}

	setMsgRuntime(" performing system calibration . . .");
	SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 0);

  	CalcWait();
	
	if(SysCal(&M201) != NULL)
	{
		setWarnPnl();
		strcpy(msgWarnPnl, errorMsg201CVI);
		textWarnPnl(SHOW_BUTTON);
		dispWarnPnl();
		return (1);
	}

     if(M201.filter < 1)
    {
		setMsgRuntime(" ....waiting filter settling time    ");
		SetCtrlAttribute(hndMainPnl, PANEL_ATTENTION_LED, ATTR_VISIBLE, 1);
		DisplayPanel (hndMainPnl);
	}
	
	/*get version */
	GetVer(&M201);

	/*set averaging  */
	setMsgRuntime(" setting remote averaging");
	SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 0);
	SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 0);
	RemoteAvg(&M201);

	/*set channel and subchannel */
	setMsgRuntime(" sending channel codes");
	SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 0);
	SetChanCode(&M201);

	/*wait filter settling time */
	setMsgRuntime(" waiting filter settling time");
	SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 0);
	SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 0);
	FilterDelay(M201.filter);
   
   	if(M201.filter < 1)
    {
		SetCtrlAttribute(hndMainPnl, PANEL_ATTENTION_LED, ATTR_VISIBLE, 0);
		DisplayPanel (hndMainPnl);
	}
		
	doSignonFlg = 0;
	
	sprintf(initBuff, 	" Successful sign-on to M201       "
													"                                "
													"   VERSION - %d", M201.version);
	setMsgRuntime(initBuff);
	SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 0);
	
NO_SIGNON:
	
	if((opMode == SINGLE_SCAN_MODE)
	  ||	(opMode == MULTI_SCAN_MODE)
	  ||	(opMode == MULTI_SCAN_CAL_MODE))
	{
// 10-23-98 =======================================================
    	if ((scanVoltData = (double *) malloc(pointXVal)) == NULL)
    	{
			setWarnPnl();
			strcpy(msgWarnPnl, errorMsg201CVI);
			textWarnPnl(SHOW_BUTTON);
			dispWarnPnl();
			setMsgRuntime("Memory allocation error. Change size of X-scale");
			SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 0);
			return (1);
    	}
//================================================================

		acquireStat = IS_RUNNING;
		SetCtrlAttribute(hndMainPnl, PANEL_STAT, ATTR_ON_COLOR, VAL_GREEN);
		SetCtrlAttribute(hndMainPnl, PANEL_STAT, ATTR_LABEL_TEXT, "- running");
		SetCtrlAttribute(hndMainPnl, PANEL_PAUSE, ATTR_LABEL_TEXT, "__Standby");
		Delay(.25);

		goto SCAN;
	}

POLLED:	

	scanPnt++;

	if(MaxMinReset)
	{
		MaxMinReset = 0;
		max = voltage;
		min = voltage;
	}

	if(getChkSumPending)
	{
		getChkSumPending = 0;		
		if(GetCheckSum ())
		{
			setMsgRuntime(" CHECKSUM   ERROR");
			SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 0);
      		setupChanged = SETUP_CHANGED;
 			flashAttention();
		}
		else
		{
			setMsgRuntime(" CHECKSUM   OK");
			SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 0);
      		setupChanged = SETUP_CHANGED;
 			flashAttention();
		}
	}
	
	if(ChanReset)
	{
      	if(M201.filter < 1)
      	{
			setMsgRuntime(" channel changed     ....waiting filter settling time    ");
			SetCtrlAttribute(hndMainPnl, PANEL_ATTENTION_LED, ATTR_VISIBLE, 1);
			DisplayPanel (hndMainPnl);
		}
		SetChanCode(&M201);
		FilterDelay(M201.filter);
		ChanReset = 0;
      	if(M201.filter < 1)
      	{
			setMsgRuntime(" Channel change complete");
			SetCtrlAttribute(hndMainPnl, PANEL_ATTENTION_LED, ATTR_VISIBLE, 0);
			SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 0);
			DisplayPanel (hndMainPnl);
		}
	}

	voltage = 0;
	
	rawCount = 0;

	for (i = 0; i < localAvg; i++)
	{

INNER_POLLED:	
		if(!ConvPendingFlg)
		{
			if(StartConversion(&M201))
			{
				if ((hndLogfile != 0) && (acquireStat == NOT_RUNNING))
				{
					fclose(hndLogfile);
					hndLogfile = 0;
				}

				acquireStat = NOT_RUNNING;
				SetCtrlAttribute(hndMainPnl, PANEL_STAT, ATTR_ON_COLOR, VAL_RED);
				SetCtrlAttribute(hndMainPnl, PANEL_PAUSE, ATTR_LABEL_TEXT, "__Standby");
				SetCtrlAttribute(hndMainPnl, PANEL_STAT, ATTR_LABEL_TEXT, "- stopped");
				setMsgRuntime(" Get-conversion initialization failure. ");
				SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 1);
				DisplayPanel (hndMainPnl);
				setWarnPnl();
				strcpy(msgWarnPnl, "\nGet-Conversion initialization failure");
				textWarnPnl(SHOW_BUTTON);
				dispWarnPnl();
				ConvPendingFlg = 0;
				return (1);
			}
		}
			
		ProcessSystemEvents();
	
		if(RequestAnswer(&M201))
		{
			/* conversion in progress */
			goto INNER_POLLED;
		}
	   	
		voltage += M201.voltage;
		rawCount += M201.rawCount;
	}

	M201.voltage = voltage/localAvg;
	M201.rawCount = rawCount/localAvg;

	StandardDev(&M201, &stDv, &rmsBits, &sdTot,
						&sdAvg, sd, &sdCount);

	/* prevent screen scramble on data-size overflow */
	if(fabs(max - min) >= 10000)
	{
		max = voltage;
		min = voltage;
	}

	sprintf (pollBuffTmp," %08ld      %9.6lf         %08.6lf              %4.1lf"
						"           CHAN - %d          %2d                       "
						"                                   \n",
						M201.rawCount,(M201.voltage) * .001, (fabs(max - min)) * .001 ,
						rmsBits, M201.channel, M201.subChan);

	if((logStat == DO_LOGGING)&& (hndLogfile != 0))
	{
		sprintf (fileBuff,"\n%07.0lf     %9.6lf",
						scanPnt, (M201.voltage) * .001);
		fwrite(fileBuff, strlen(fileBuff), 1, hndLogfile);
	}

	SetCtrlVal(hndMainPnl, PANEL_POLL_LINE_INDICATE, 15 - pollLineNum);

	if(pollLineNum == 15)
	{
		pollLineNum = 0;
	}

	if(pollLineNum == 0)
	{
		for(i2 = 0; i2 < 147; i2++)
			memset (&pollBuff[i2], pollBuffTmp[(unsigned char)i2], 1);
			memset (&pollBuff[((149 * pollLineNum ) + i2)],
					(char)'\n', 1);
	}
	else
	{
		for(i2 = 0; i2 < 149; i2++)
			memset (&pollBuff[((149 * pollLineNum ) + i2) - 1],
					pollBuffTmp[(unsigned char)i2], 1);
	}
	
	SetCtrlVal(hndMainPnl, PANEL_POLL_LINE_INDICATE, (15 - pollLineNum));
	
	ResetTextBox(hndMainPnl, PANEL_POLL_DISPLAY, pollBuff);

	pollLineNum++;
	if (max < M201.voltage)
	{
		/*update maximum */
		max = M201.voltage;
	}

	if (min > M201.voltage)
	{
		/*update minimum */
		min = M201.voltage;
	}

	M201.voltage = 0;
	M201.rawCount = 0;

	/* end of current polled acquisition */
	return 0;

SCAN:

GET_SCANS:

	ProcessSystemEvents();

	/* preserve values for current channel and subchannel */
	/*
	tempCh = M201.channel;
	tempSub = M201.subChan;
	*/

	M201.sleeping = 0;
	M201.numChannels = 0;
	activeChannelIndex = 0;
	
	/*initialize control code array and calculate total number of points per scan */
  	for (n = 0; n <= 5; n++)    
  	{
	 	if(M201.chan[n] != 0xf0)
	 	{
	 		cc[n] = ((M201.chan[n] & 0x0f) - (M201.chan[n] >> 4)) + 1;
	 		/*figure total number of channels/scan */
	 		M201.numChannels += cc[n]; 
	 	}
  	}
 
	/* Calculate the ActiveChannelIndex   */
	activeChannelIndex = 0;
	activeChannel = M201.channel;
	for (n = 0; n <6; n++)
	{
		for (s = 0; s <16; s++)
		{
		 	if (subChanSelect[n][s] == 's')
		 	{
		 		activeChannelIndex++;
		 		if ((n==activeChannel)&&(s==activeSubChannel)) goto DONETHIS;
		 	}
		}
	}
DONETHIS:  if(activeChannelIndex) activeChannelIndex--;

	if (M201.tScan == 0)
	{

		M201.subChan = M201.singleChan & 0x0f;
		M201.channel = M201.singleChan >> 4;

		/*set control code for single channel scanning */
		SetChanCode(&M201);
		ProcessSystemEvents();
		
		/* if single channel, use to index first voltage in scanDataArray */
		activeChannelIndex = 0;
	}

	/*Start scanning using selected scan type */
	if(StartScanning(&M201))
	{
		setMsgRuntime("start-scan error");
		SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 1);
		SetCtrlAttribute(hndMainPnl, PANEL_PAUSE, ATTR_DIMMED, 1);
// 10-23-98 =======================================================
		free (scanVoltData);
		scanVoltData = NULL;
//================================================================
		return 1;
	}

	if(initCnt < 1)
	{
		sprintf(initBuff, " Beginning scan sequence."
					  "                   MODEL 201 -- VERSION-%d", M201.version);
		setMsgRuntime(initBuff);
		SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 0);
	}
	
  	scanWords = M201.numChannels * M201.wordCnt + 2;

  	if(M201.tScan == 2)
  	{
	 	scanWords +=(M201.wordCnt * 2);
  	}
  	else if(M201.tScan == 0)
  	{
	 	scanWords = M201.wordCnt;
  	}
		
	SetCtrlAttribute(hndMainPnl, PANEL_PAUSE, ATTR_DIMMED, 1);
  	
	SetCtrlVal(hndMainPnl, PANEL_BUFF_STAT_LED, 1);
	numPlotPoint = (int)(.05 / M201.scanInterval);

SCANSTATUS:

	if(ChanReset)
	{
		if(M201.tScan == 0)
		{
			M201.subChan = M201.singleChan & 0x0f;
			M201.channel = M201.singleChan >> 4;
			SetChanCode(&M201);
			ChanReset = 0;
		}
	}

	while(acquireStat == IS_RUNNING)
	{
		initCnt++;

		if(initCnt == 2)
		{
			sprintf(initBuff, " Proper data acquisition performance.       "
							  "     MODEL 201 -- VERSION-%d", M201.version);
			setMsgRuntime(initBuff);
			SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 0);
			DisplayPanel (hndMainPnl);
		}

		/* used only for message display functionality */
		if(initCnt > 4) initCnt = 4;

INNER_SCAN_LOOP:

		scanStatus = GetOneScan(&M201);
		switch(scanStatus)
		{
			case SCAN_NOT_DONE:
	
				ProcessSystemEvents();
				if(acquireStat == NOT_RUNNING)
					goto END_SCANS;
				goto INNER_SCAN_LOOP;	
				break;
		
			case SCAN_DONE:
				curInQueue = curQLen;
				
				
				if(opMode == MULTI_SCAN_CAL_MODE)
				{
					/* prepare to update display if Active channel and subchannel */
					/* first two members are full and offset call values */
					scanVoltData[(int)graph_X2] = 	   							//7-29-98
							scanDataArray[activeChannelIndex + 2] * .001;   	//7-29-98
				}
				else
				{
					/* prepare to update display if Active channel and subchannel */	
					scanVoltData[(int)graph_X2] = 				  				//7-29-98
								scanDataArray[activeChannelIndex] * .001;   	//7-29-98
				}
				
				if(opMode != SINGLE_SCAN_MODE)
				{
					if(M201.chan[M201.channel] == 0xf0)
					{
						SetCtrlAttribute(hndMainPnl, PANEL_NO_ACTIVE_SUB, ATTR_VISIBLE, 1);
						goto NO_ACTIVE;
					}
					else
					{
						SetCtrlAttribute(hndMainPnl, PANEL_NO_ACTIVE_SUB, ATTR_VISIBLE, 0);
					}
				}
				
				if(fmod(graph_X2, numPlotPoint) == 0) 
				{
					
					if(opMode == MULTI_SCAN_CAL_MODE)
					{
						/* Update Display if Active channel and subchannel */	
						sprintf (scanBuff," %9.6lf", 					   //7-29-98
							scanDataArray[activeChannelIndex + 2] * .001); //7-29-98
						ResetTextBox(hndMainPnl, PANEL_SCAN_DISPLAY, scanBuff);
					}
					else
					{
						/* Update Display if Active channel and subchannel */
						sprintf (scanBuff," %9.6lf", 					  //7-29-98
							scanDataArray[activeChannelIndex] * .001);    //7-29-98
						ResetTextBox(hndMainPnl, PANEL_SCAN_DISPLAY, scanBuff);
					}
					
					DeleteGraphPlot(hndMainPnl, PANEL_WAVEFORM, -1, VAL_DELAYED_DRAW);
					
					hndPlot = PlotY (hndMainPnl, PANEL_WAVEFORM, scanVoltData, graph_X, 
						VAL_DOUBLE, VAL_THIN_LINE, VAL_EMPTY_SQUARE, VAL_SOLID, 1, VAL_RED);
					
					hndPlotLine = PlotLine (hndMainPnl, PANEL_WAVEFORM, graph_X2, 
									0-5, graph_X2, 5, VAL_BLUE);
				}
				
				graph_X2++;
				if(graph_X2 > pointXVal + 1) graph_X2 = 0;
				
				graph_X++;
				if(graph_X > pointXVal + 1) graph_X = pointXVal + 1;
				
NO_ACTIVE:
				
				/* Update Log file if active */
				if(logStat == DO_LOGGING)
				{
 					sprintf (fileBuff,"\n%07.0lf      %9.6lf",
						scanNum, scanDataArray[0] * .001);
					fwrite(fileBuff, strlen(fileBuff), 1, hndLogfile);
					
 					if(opMode != SINGLE_SCAN_MODE)
 					{
						sprintf(fileBuffExt, "%s", "");
						
						if(opMode == MULTI_SCAN_CAL_MODE)
						{
							sprintf (fileBuff,"   %9.6lf   %9.6lf", 
								scanDataArray[1] * .001,
								scanDataArray[2] * .001);
							strcat(fileBuffExt, fileBuff);
							for(scanArrayIndex = 3; 
								(int)scanArrayIndex < (M201.numChannels + 2); 
								scanArrayIndex += 1)
							{
								sprintf (fileBuff,"   %9.6lf", 
									scanDataArray[(int)scanArrayIndex] * .001);
								strcat(fileBuffExt, fileBuff);
							}
						}
						else
						{
							for(scanArrayIndex = 1; 
								(int)scanArrayIndex < M201.numChannels; 
								scanArrayIndex += 1)
							{
								sprintf (fileBuff,"   %9.6lf", 
									scanDataArray[(int)scanArrayIndex] * .001);
								strcat(fileBuffExt, fileBuff);
							}
						}
						fwrite(fileBuffExt, strlen(fileBuffExt), 
									sizeof(char), hndLogfile);
					}
				}
			
				if (curInQueue < (scanWords * 4))
				{
					if(scanStatLED != GREEN_LED)
					{
						scanStatLED = GREEN_LED;					
						SetCtrlAttribute(hndMainPnl, PANEL_BUFF_STAT_LED, 
								ATTR_ON_COLOR, VAL_GREEN);
					}
				}
			
				if (curInQueue > (scanWords * 4))
				{
					if(scanStatLED != YELLOW_LED)
					{
						scanStatLED = YELLOW_LED;					
						SetCtrlAttribute(hndMainPnl, PANEL_BUFF_STAT_LED, 
								ATTR_ON_COLOR, VAL_YELLOW);
					}
				}
			
				if(curInQueue > (M201.RXQUEUESIZE * .75))
				{
					if(scanStatLED != RED_LED)
					{
						scanStatLED = RED_LED;					
						SetCtrlAttribute(hndMainPnl, PANEL_BUFF_STAT_LED, 
								ATTR_ON_COLOR, VAL_RED);
					}
				}
			
				if(curInQueue > (M201.RXQUEUESIZE * .9))
				{
					scanErrorFlg = SCAN_BUFF_OVERFLOW;
					goto END_SCANS;
				}

				tempMOD = (int)(curInQueue / scanWords);
				if(tempMOD > 100) tempMOD = 100;
				if(fmod(scanNum, tempMOD) == 0) 
				{
					curInQueue = GetInQLen(M201.comPort+1);
					ProcessSystemEvents();
				}
			
				scanNum++;
				goto SCANSTATUS;

				break;
		
			/* STOP Scanning due to scan time out error */
			case SCAN_TIMEOUT:

ERROR_EXIT:		
			if ((hndLogfile != 0) && (acquireStat == NOT_RUNNING))
			{
				fclose(hndLogfile);
				hndLogfile = 0;
			}
			acquireStat = NOT_RUNNING;
			SetCtrlAttribute(hndMainPnl, PANEL_STAT, ATTR_ON_COLOR, VAL_RED);
			SetCtrlAttribute(hndMainPnl, PANEL_PAUSE, ATTR_LABEL_TEXT, "__Pause");
			SetCtrlAttribute(hndMainPnl, PANEL_STAT, ATTR_LABEL_TEXT, "- stopped");
			setMsgRuntime(" Data Acquisition stopped.");
			SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 0);
			
			StopScanning(&M201);
			doSignonFlg = 1;
			setWarnPnl();
			if(scanErrorFlg == SCAN_IN_PROGRESS_ERROR)
				strcpy(errorMsg201CVI, "\n Scanning error. \n\n"
							" Exiting from scan routine");
			strcpy(msgWarnPnl,  errorMsg201CVI);
			textWarnPnl(SHOW_BUTTON);
			dispWarnPnl();
			acquireStat = NOT_RUNNING;
			SetCtrlAttribute(hndMainPnl, PANEL_STAT, ATTR_ON_COLOR, VAL_RED);
			SetCtrlAttribute(hndMainPnl, PANEL_STAT, ATTR_LABEL_TEXT, "- stopped");
			SetCtrlAttribute(hndMainPnl, PANEL_PAUSE, ATTR_DIMMED, 0);

 			if(hndStandbyPnl)
			{
				DiscardPanel(hndStandbyPnl);
				hndStandbyPnl = 0;
			}
			
			if(exitFlag)						//7-30-98
			{									//7-30-98
				exitFlag = 0;					//7-30-98
				if(openComFlag)					//7-30-98
				{								//7-30-98
					CloseCom(M201.comPort+1);   //7-30-98
					openComFlag = 0;			//7-30-98
				}								//7-30-98
				exit(1);						//7-30-98
			}									//7-30-98

			return 1;
			break;
		}
	}
	

/* Normal Stop Scanning */
END_SCANS:
		
	if(scanErrorFlg == SCAN_BUFF_OVERFLOW)
	{
		acquireStat = NOT_RUNNING;
		hndStandbyPnl = LoadPanel (0, "standby.uir", STANDBY);
		SetCtrlAttribute(hndStandbyPnl, STANDBY_LOG_TXT, 
										ATTR_VISIBLE, 0);
		DisplayPanel (hndStandbyPnl);
		SetCtrlAttribute(hndStandbyPnl, STANDBY_LOG_TXT, 
										ATTR_VISIBLE, 0);
	}
	
	ProcessSystemEvents();
	
	if(logStat == DO_LOGGING)
		finishLogScan();
	else
		StopScanning(&M201); 
	
	SetCtrlAttribute(hndStandbyPnl, STANDBY_LOG_TXT, 
					ATTR_VISIBLE, 0);

	if((acquireStat == IS_RUNNING) && (M201.tScan != 0))
	{
		/* still running so go back for more */
		 ProcessSystemEvents();
		 goto GET_SCANS;
	}
	
	SetCtrlAttribute(hndMainPnl, PANEL_PAUSE, ATTR_DIMMED, 0);

EXIT_POINT:
// 10-23-98 =======================================================
		SetCtrlAttribute(hndMainPnl, PANEL_X_AXIS_RANGE, ATTR_DIMMED, 0);
		free (scanVoltData);
		scanVoltData = NULL;
//================================================================

	if(hndStandbyPnl)
	{
		DiscardPanel(hndStandbyPnl);
		hndStandbyPnl = 0;
		if (hndLogfile)
		{
			fclose(hndLogfile);
			hndLogfile = 0;
		}
	}

	acquireStat = NOT_RUNNING;
	SetCtrlAttribute(hndMainPnl, PANEL_STAT, ATTR_ON_COLOR, VAL_RED);
	SetCtrlAttribute(hndMainPnl, PANEL_PAUSE, ATTR_LABEL_TEXT, "__Pause");
	SetCtrlAttribute(hndMainPnl, PANEL_STAT, ATTR_LABEL_TEXT, "- stopped");
	
	if(scanErrorFlg == SCAN_BUFF_OVERFLOW)
	{
		scanErrorFlg = SCAN_NO_ERROR;
		setMsgRuntime(" Scan buffer full                "
						". . . . . . scan terminated without other errors");
		SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 1);
	}
	else
	{
		setMsgRuntime(" Data Acquisition stopped.");
		SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 0);
	}
	
	scanStatLED= GREEN_LED;					
	
	SetCtrlAttribute(hndMainPnl, PANEL_BUFF_STAT_LED, 
								ATTR_ON_COLOR, VAL_GREEN);
	
	if(exitFlag)						//7-30-98
	{									//7-30-98
		exitFlag = 0;					//7-30-98
		if(openComFlag)					//7-30-98
		{								//7-30-98
			CloseCom(M201.comPort+1);   //7-30-98
			openComFlag = 0;			//7-30-98
		}								//7-30-98
		exit(1);						//7-30-98
	}									//7-30-98
	
	return 0;
}

/*----- END OF INIT_201 FUNCTION ------------*/
/*********************************************/

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

/****** FINISHLOGSCAN FUNCTION ***************/
/*-------------------------------------------*/

/* if no error, and logging to data file,  then current contents 
/*   of input buffer are written to logfile before exiting */
int finishLogScan()
{
 	
	SetCtrlAttribute(hndStandbyPnl, STANDBY_LOG_TXT, 
					ATTR_VISIBLE, 1);
	DisplayPanel (hndStandbyPnl);
	/* send stop scan token */
  	SendPacket(0x8A,0);	

  	/* wait 1.5 scans */
  	WaitXX(ConvWait*1.5);		
							

FINISH_LOG_LOOP:
	
  	if(GetInQLen(M201.comPort+1) <= 1)
	{
		WaitChar(1, 1, cbuf);
  		
  		if(b != 0x8A)       
  		{
			if(hndLogfile)
			{
				fclose(hndLogfile);
				hndLogfile = 0;
			}
	 		return 1;
  		}

  		buffer_size = 0;
  	
  		/* restore channel and extcode */
  		SendPacket(1,M201.channel * 16 + M201.subChan); 
		if(hndLogfile)
		{
			fclose(hndLogfile);
			hndLogfile = 0;
		}
  		return 0;
	}
	else
	{
		scanStatus = GetOneScan(&M201);
		switch(scanStatus)
		{
			case SCAN_NOT_DONE:

				goto FINISH_LOG_LOOP;	
				break;
		
			case SCAN_DONE:
 	
 				sprintf (fileBuff,"\n%07.0lf      %9.6lf",
						scanNum, scanDataArray[0] * .001);
				fwrite(fileBuff, strlen(fileBuff), 1, hndLogfile);
					
				if(opMode != SINGLE_SCAN_MODE)
 				{
					sprintf(fileBuffExt, "%s", "");
			
					if(opMode == MULTI_SCAN_CAL_MODE)
					{
						sprintf (fileBuff,"   %9.6lf   %9.6lf", 
							(scanDataArray[1]) * .001,
							(scanDataArray[2]) * .001);
						strcat(fileBuffExt, fileBuff);
						for(scanArrayIndex = 3; 
							(int)scanArrayIndex < (M201.numChannels + 2); 
							scanArrayIndex += 1)
						{
							sprintf (fileBuff,"   %9.6lf", 
							(scanDataArray[(int)scanArrayIndex]) * .001);
							strcat(fileBuffExt, fileBuff);
						}
					}
					else  /* multi-scan without calibration mode */
					{
						for(scanArrayIndex = 1; 
								(int)scanArrayIndex < M201.numChannels; 
								scanArrayIndex += 1)
						{
							sprintf (fileBuff,"   %9.6lf", 
								(scanDataArray[(int)scanArrayIndex]) * .001);
							strcat(fileBuffExt, fileBuff);
						}
					}
					fwrite(fileBuffExt, strlen(fileBuffExt), 
					sizeof(char), hndLogfile);
				}

			scanNum++;

			/* Update Buffer level indicator */			
			curInQueue = GetInQLen(M201.comPort+1);
			SetCtrlVal(hndMainPnl, PANEL_BUFF_STAT_LED, 1);
			if (curInQueue < (64 * M201.numChannels))
				SetCtrlAttribute(hndMainPnl, PANEL_BUFF_STAT_LED, 
								ATTR_ON_COLOR, VAL_GREEN);
			if (curInQueue > (64 * M201.numChannels))
				SetCtrlAttribute(hndMainPnl, PANEL_BUFF_STAT_LED, 
								ATTR_ON_COLOR, VAL_YELLOW);

			goto FINISH_LOG_LOOP;
		}
	}
	return 0;
}
/*----- END OF FINISHLOGSCAN FUNCTION -------*/
/*********************************************/

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

/****** STANDARDDEV FUNCTION *****************/
/*-------------------------------------------*/
/*standard deviation and RMS resolution calculation  */
//double stDv=0, rmsBits=0, sdTot = 0, sdAvg=0, sd[41];

void    StandardDev(T_M201 *M201,
						  double *stDv,
						  double *rmsBits,
						  double *sdTot,
						  double *sdAvg,
						  double *sd,
						  int    *sdCount)
{
	int i = 0, nnn,sdGrp = 40, bits;
	double tempStDv;
	char tempBuff[128];

  	sd[*sdCount] = M201->rawCount;
  	(*sdTot) += M201->rawCount;

  	if ((*sdCount) == sdGrp)
  	{
		//sprintf(tempBuff, "%s", "timtest-1");
		//MessagePopup ("", tempBuff);
	 	(*stDv) = 0;
	 	(*sdTot) = (*sdTot) / sdGrp;

	 	for (nnn = 1; nnn != sdGrp; nnn++)
	 	{
			(*stDv) = (*stDv) + ((*sdTot) - sd[nnn])*((*sdTot) - sd[nnn]);
	 	}

	 	(*stDv) = sqrt((*stDv) / (sdGrp-1));
	 	tempStDv = (*stDv);

CALCNEXT:

	 	if (tempStDv >= 1)
	 	{
			i = i + 1;
			tempStDv = tempStDv / 2;
			goto CALCNEXT;
	 	}

	 	if (M201->wordCnt == 3)
	 	{
			bits = 24;
	 	}
	 	else
	 	{
			bits = 16;
	 	}

	 	(*rmsBits) = bits - i;

	 	if ((tempStDv < .75) && (i != 0))
	 	{
			(*rmsBits) = (*rmsBits) + .5;
	 	}

	 	(*sdAvg) = Counts2Volts((long)(*sdTot),
											 M201->wordCnt,
											 M201->biPolar);

	 	(*stDv) = Counts2Volts((long)(*stDv),
											 M201->wordCnt,
											 M201->biPolar);

	  	if (M201->biPolar)
	  	{
		 	(*stDv) += 5000;					/*unipolar voltage range */
	  	}

	 	(*sdTot) = 0; (*sdCount) = 1;
  	}
  	else
  	{
	 	(*sdCount)++;
  	}

}

/*----- END OF STANDARDDEV FUNCTION ---------*/
/*********************************************/

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

/****** CALCSCANTIME FUNCTION ****************/
/*-------------------------------------------*/

/****************************************************************************
Because all aspects of the scanning function of the Model 201 is programmable,
it can be difficult to determine what the optimal settings are for any
particular task. Also, if the A/D is not performing as intended, it can be
hard to determine the cause. An overview of how to set up the 201 from a
programmer's perspective follows.

The A/D is constantly performing conversions at DATARATE. This rate is set in
the mode registers of the A/D chip itself. Slower DATARATEs provide lower
noise, higher DATARATEs allow higher frequencies to be seen, and allow more
data points to be taken in the same time period.

For higher frequency applications the DATARATE should be set for the
appropriate low-pass filter cutoff frequency. The cutoff frequency is
approximately one quarter the DATARATE.

For DC and very low frequency applications, you would normally select the
lowest possible DATARATE. That lowest rate is determined by all the
programmable scanning variables - scan type, the number of channels scanned,
averaging, filter setting, word length and BAUD rate. Even though the
DATARATE is actually sent to the A/D before the rest of the scanning details
during the sign-on process, it should be calculated last. Details for Model
201 follow:


  M201.baud           = 0 for 9600, 1 for 4800, etc.
  M201.numChannels    = number of channels to scan
  M201.average        = number of conversions to average
								(1, 2, 4, 8, 16, 32 etc)
  M201.wordCnt        = number of bytes in conversion ( 2 or 3)
  M201.filter;		  = 0 = 4 Hz, 1 = 40 Hz, 2 = 400 Hz filter

  For the Model 201, fTime is based on the M201.filter setting:
	 0 (4 Hz), fTime = 4.5 seconds
	 1 (40 Hz), fTime = .56 seconds
	 2 (400 Hz), fTime = .036 seconds

Here, we have solved for the minimum sample rate given the scan interval:

  minSampleRate = (M201.average + 2) / ((M201.scanInterval - (M201.wordCnt *
				 .002333) * 2 ^ M201.baud) / M201.numChannels - (fTime * .82));

A 5 percent margin should provide comfort. The following line would take
care of that:

  M201.rate = 1.05 * minSampleRate;
*************************************************************************** */

/*select the scan interval  */
short CalcScanTime(T_M201 *M201)
{
	double minTime, maxTime;
	char tmpbuf[80];
	short i;
	char tempBuff[120];

CALCSCANTIME1:

  if(M201->numChannels == 0)
  {
	 return 0;
  }
  if (opMode == POLLED_MODE) M201->tScan = 0;                 
  i = CheckScanTime(M201, &maxTime, &minTime);

  if (i==2)
  {
		sprintf(tempBuff, " Attempting to reconfigure with averaging"
								" reduced to %d", M201->average);
		setMsgRuntime(tempBuff);
		SetCtrlVal(hndMainPnl, PANEL_WARNING_MSG, 1);
  }
  else if(!i)
  {
		/* tim NOTE:  implement this! */
		goto CALCSCANTIME1; 
		return (0);
  }

  return 1;
}


/*----- END OF STANDARDDEV FUNCTION ---------*/
/*********************************************/

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

/****** TEMPLATES AND OTHER STUFF ************/
/*-------------------------------------------*/

/* tim 9/26 N O T E : maybe do something with this later!!!
if (M201.sleeping)
	 {

/*
	MessagePopup ("", test());   /* test for call to function in module.obj
											defined in module.h --- SAVE FOR TESTING!!!
*/

/*
	sprintf(tempBuff, "%d", lowSub);
	MessagePopup ("", tempBuff);
	sprintf(tempBuff, "%d", highSub);
	MessagePopup ("", tempBuff);
*/

/*
	GenericMessagePopup ("N O T I C E", "ready to start user interface",
				"continue", "abort", "reset values",0,0,22,1,1,2);
*/

/*
		setStatPnl();
		strcpy(msgStatPnl, "\nSaving configuration to:\n\n"
									"M201_CVI.CFG ");
		textStatPnl(HIDE_BUTTON);               /* show OK button
		dispStatPnl();
		dotStatPnl(10, .125, TRUE);
*/

/*-------------------------------------------*/
/*********************************************/


	

