/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

/* prevent mulitple includes */
#ifndef MODEL201_H
#define MODEL201_H

/****** GLOBAL VARIABLES AND MACROS **********/
/*-------------------------------------------*/

#define BYTES_PER_LONG 4

#define SCAN_NO_ERROR 0
#define SCAN_START_FAILURE 1
#define SCAN_IN_PROGRESS_ERROR 2
#define SCAN_BUFF_OVERFLOW 3
char scanErrorFlg = SCAN_NO_ERROR;


#define DIGIN_NOT_PENDING 0
#define DIGIN_PENDING 1
char digInFlg = DIGIN_NOT_PENDING;

/* logging or not logging status */
#define NO_LOGGING 0
#define DO_LOGGING 1
int logStat = NO_LOGGING;

/* current setup selection status */
#define NO_PENDING 0
#define PORT_SET_PENDING 1
#define BAUD_SET_PENDING 2
#define CUT_OFF_FREQ_SET_PENDING 3
#define POLARITY_SET_PENDING 4
#define FILTER_SET_PENDING 5
#define AVERAGE_SET_PENDING 6
#define WORD_LENGTH_SET_PENDING 7
#define SCAN_INTERVAL_SET_PENDING 8
char miscSetup = NO_PENDING;

#define SETUP_NOT_CHANGED 0
#define SETUP_CHANGED 1
char setupChanged = SETUP_NOT_CHANGED;


/* used to determing file logging status */
int logging = NO_LOGGING;

/* default logfile increment */
int logfileNum = 1;

char logfileEntryPassFlg = 0;
char overwriteOnceFlg = 0;

/* flag file overwrite status */
#define OVERWRITE_ALL 0
#define OVERWRITE_PROMPT 1
#define DO_OVERWRITE 2
#define DONT_OVERWRITE 3
#define OVERWRITE_ERROR 4
char fileOverwriteFlg = OVERWRITE_PROMPT;

char fileOverwritePrmpt = 0;
char logfileNumArray [5];
long fileSize = 0;
char logfileNameTmp[120];
char logfileName [120];
FILE *hndLogfile = 0;

/* used to display current setup in string format */
char baudString[50];
char comString[20];
char scanIntString[120];
char cutOffFreqString[50];
char avgString[30];
char filterString[30];
char wordLengthString[30];
char *dotPtr, dot = '.';

/* for formatted time */
time_t t2;


/* handle to graph. used for plotting data */
int hndPlot = 0;

double pointXVal = 0;
double pointYValPos = 0;
double pointYValNeg = 0;
int graphBkgrndColor = 0;

/* prevents double handling of sub-channel select under certain circumstances */
subSetPassFlg = 0;

/* similiar to above line. Some events are triggered indirectly when it is
	undesirable for total processing of event */
quickSelPassFlg = 0;

/* holds current status of sub-channel selection for multi-scan modes*/
char subChanSelect[9][17];

/* points to sub-channel array member. 's' == set    'c' == clear */
int subChanArrayPtr = 0;

/* simplifies usage of subChanArrayPtr int */
#define SCAptr subChanArrayPtr

/* zero based offset into subChanSelect array */
/* note that these defines must be kept sequentially ordered */
/* in header file. If an error occurs while referencing them, */
/* that would be a place to take a look */
#define CTRL_OFFSET  15 - (int)fmod((double)PANEL_C15, (double)ctrlNum)

/* this is used to hold the value of the maximum scan interval displayed */
/* on the slide bar on the main panel */
double curScanIntMax = 1.000;

double stDv=0, rmsBits=0, sdTot = 0, sdAvg=0, sd[41];
int sdCount=1;

/* used in polled mode to determine if max-min values have been reset */
char MaxMinReset = 0;

int ChanReset = 0;
char getChkSumPending = 0;
char doSignonFlg = 0;
char chgModePendingFlg = 0;
/* used for changing digital outputs */
int digOutArray[9] = {0, 0, 0, 0, 0, 0, 0, 0};
int newDigOut = 0;

/* used for getting and manipulating digital inputs */
int digInArray[9] = {0, 0, 0, 0, 0, 0, 0, 0};
int newDigIn = 0;


/* used in polled mode display on main panel. Holds value of current display
	line number */
int pollLineNum = 0;

/* used in polled mode to temporarily hold formatted output of values recieved
	by external device */
char pollBuffTmp[150];

/* main buffer used by polled mode for screen output data */
char pollBuff[3000];

/* multi-function shared variables */
int retval = 0;					/* return value from function calls */

/* pointer to setMsgRuntime function */
int(*setMsgRuntimePtr)(char*);

short localAvg  = 1;

/* handle to external module "201CVI.OBJ" */
int hnd201CVI_MODULE = 0;

int hndStandbyPnl = 0;

/* main panel global variables */
double 	datapoints	[721];
BOOL existMainPnl = FALSE;
int hndMainPnl;

char msgMainPnl [120];

int hndFileWarnPnl = 0;

/* stat panel global variables */
BOOL existStatPnl = FALSE;
int hndStatPnl;
char msgStatPnl[180];
int setStatPnl(void);
int dispStatPnl(void);
int textStatPnl(BOOL button);
int dotStatPnl(int num, double delay, BOOL destroy);
/* N O T E : following function not currently used. May be used later
	to dynamically add controls to textStatPnl */
int 		cntlStatPnl(BOOL show, int ID);

/* warning panel variables */
int hndWarnPnl;
char msgWarnPnl[220];

/*----- END OF GLOBAL VARIABLES -------------*/
/*********************************************/

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

/****** MISC PROTOTYPES **********************/
/*-------------------------------------------*/

T_M201  M201;

/*----- END OF MISC PROTOTYPES --------------*/
/*********************************************/

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

/****** LOCAL FUNCTION PROTOTYPES ************/
/*-------------------------------------------*/
/*select the scan interval */
int finishLogScan(void);
int setActiveSubChan(void);
void chgSetupWait(void);
void flashAttention(void);

short   CalcScanTime(T_M201 *M201);

int testFuncPass(int(*funcPtr)(void));
int doTest(void);

/* process sub-channel change requests */
int chgSubChan(int cntrlNum, int event);

/* read 201EWIN.CFG file from disk in current directory */
short   	ReadConfig(void);

/* unable to read config, or config override -- set defaults */
short 	setDefaults(BOOL dispDlg);

/* write 201EWIN.CFG file to disk in current directory */
short   	WriteConfig(void);

/* entry point into standard 201 code (was main()) */
int 		init_201(void);

/* handles focus events in main panel */
int 		focusMainPnl(int panel, int event, void *callbackData,
					int eventData1, int eventData2);

/* handles event for push-button to set main panle defaults */
int  		setDefMainPnl(int panel, int control, int event,
					void *callbackData, int eventData1, int eventData2);

/* set the controls on the main panel */
int		setMainPnlCtrls(void);

/* handler for  STOP button on main panel */
int  		stopMainPnl(int panel, int control, int event,
				void *callbackData, int eventData1, int eventData2);

void    StandardDev(T_M201 *M201,		/*calculate standard deviation  */
						  double *stDv,
						  double *rmsBits,
						  double *sdTot,
						  double *sdAvg,
						  double *sd,
						  int    *sdCount);

/*
/* misc functions for handling messages for status display panel
int		setStatPnl(void);
int		dispStatPnl(void);
int 		textStatPnl(BOOL button);
int 		dotStatPnl(int num, double delay, BOOL destroy);
 N O T E : following function not currently used. May be used later
	to dynamically add controls to textStatPnl
int 		cntlStatPnl(BOOL show, int ID);
*/

/* misc functions for handling messages for warning display panel */
int		setWarnPnl(void);
int		dispWarnPnl(void);
int 		textWarnPnl(BOOL button);
int 		dotWarnPnl(int num, double delay, BOOL destroy);
/* N O T E : following function not currently used. May be used later
	to dynamically add controls to textStatPnl */
int 		cntlWarnPnl(BOOL show, int ID);

/* sets messages in Run-time message control box */
int 		setMsgRuntime(char* msg);

/*----- END OF LOCAL FUNCTION PROTOTYPES ----*/
/*********************************************/

#endif
